import 'dart:io';

class XLibStorage {
  static String filePath = ".";

  //Se non c'è lo crea
  static Future<File?> GetFile(String fileName) async {
    try {
      var file = File(filePath + "/" + fileName + ".txt");
      if (!await file.exists()) {
        file = await file.create();
      }
      return file;
    } catch (ex) {
      print(ex);
      return null;
    }
  }

  static Future<bool> ExistsFileAsync(String fileName) async {
    try {
      var file = await GetFile(fileName);
      return await file!.exists();
    } catch (ex) {
      return false;
    }
  }

  static Future<File?> CreateFile(String fileName, {String? path, String? extensionFile}) async {
    try {
      var file = File((path ?? filePath) + "/" + fileName + "." + (extensionFile ?? "txt"));
      if (!await file.exists()) {
        file = await file.create();
      }
      return file;
    } catch (ex) {
      print(ex);
      return null;
    }
  }

  static Future SaveDataFileAsync(String fileName, String textData) async {
    try {
      var file = await GetFile(fileName);
      var sink = file!.openWrite();
      sink.write(textData);
      await sink.flush();
      await sink.close();
    } catch (ex) {
      print(ex);
    }
  }

  static Future<String> ReadTextAsync(String fileName) async {
    String content = "";
    try {
      var file = await GetFile(fileName);
      if (file == null) return "";
      content = await file.readAsString();
    } catch (ex) {
      print(ex);
    }
    return content;
  }
}
