import 'package:flutter_web_plugins/flutter_web_plugins.dart';
import 'dart:html' as html;

class XPathUrlStrategy extends PathUrlStrategy {
  XPathUrlStrategy([
    this.partOfURL,
    this.platformLocation = const BrowserPlatformLocation(),
  ])  : _basePath = stripTrailingSlash(extractPathname(checkBaseHref(
          platformLocation.getBaseHref(),
        ))),
        super(platformLocation);
  final PlatformLocation platformLocation;
  final String _basePath;
  final String? partOfURL;
  String get host => html.window.location.host;
  String get protocol => html.window.location.protocol;
  @override
  String prepareExternalUrl(String internalUrl) {
    if (internalUrl.isNotEmpty && !internalUrl.startsWith('/')) {
      internalUrl = '/$internalUrl';
    }
    // ricompongo url che si aspetta
    var c = partOfURL ?? '/dash/index.html?';
    return c;
  }

  @override
  String getPath() {
    // the hash value is always prefixed with a `#`
    // and if it is empty then it will stay empty
    final String path = platformLocation.hash;
    assert(path.isEmpty || path.startsWith('#'));

    // We don't want to return an empty string as a path. Instead we default to "/".
    if (path.isEmpty || path == '#') {
      return '/';
    }
    // At this point, we know [path] starts with "#" and isn't empty.
    return path.substring(1);
  }
}
