part of xwidgetbase;

class XBtnbase extends StatelessWidget {
  final String? label;
  final TextStyle? label_Style;
  final AlignmentGeometry? alignmentLabel;

  ///Da il colore a tutti i tipi di testo
  final Color? label_Color;
  final IconData? icon;
  final Color? icon_Color;
  final double? icon_Size;

  final double? width;
  final double? height;
  final Color? backGroundColor;
  final Decoration? decoration;
  final double? radiusBorder;
  final double? elevation;
  final double? icon_WidthArea;
  final EdgeInsets? padding;
  final EdgeInsets? margin;
  final bool? enableFeedback;

  final String? nameOfPageToGo;
  final BuildContext? context_buildPage;
  final Function()? onPressed;
  final TextAlign? label_TextAlign;
  final Widget? icon_Widget;
  final String? toolTip_Message;

  XBtnbase({
    this.label = "",
    this.decoration,
    this.icon_Widget,
    this.enableFeedback = true,
    this.padding,
    this.margin,
    this.radiusBorder,
    this.width,
    this.height,
    this.alignmentLabel,
    this.elevation,
    this.context_buildPage,
    this.icon,
    this.label_TextAlign,
    this.nameOfPageToGo = "",
    this.label_Style,
    this.icon_Size = 28,
    this.backGroundColor,
    this.label_Color,
    this.icon_Color,
    this.onPressed,
    this.icon_WidthArea,
    this.toolTip_Message,
  });

  static onlyBorderAndLabel({
    String? label = "Inserisci Label",
    double? widthBTN = 250,
    double? heightBTN,
    Function()? onPressed,
    Color? colorBorder = Colors.greenAccent,
    double? widthBorder = 2,
    Color? colorBackGround,
    Color? labelColor = Colors.greenAccent,
    TextAlign? textAlignLabel = TextAlign.center,
    double? borderRadius = 5,
  }) {
    return XBtnbase(
      elevation: 0,
      width: widthBTN,
      height: heightBTN,
      label_TextAlign: textAlignLabel,
      label: label,
      label_Style: XStyles.xStyTextForLabel(labelColor ?? colorBorder),
      decoration: XDecoration.onlyBorder(
        borderRadius: borderRadius!,
        colorBackGround: colorBackGround ?? Colors.grey[900],
        widthBorder: widthBorder!,
        colorBorder: colorBorder!,
      ),
      onPressed: onPressed,
    );
  }

  static ForMenu({
    String? label = "Inserisci Label",
    double? widthBTN = 250,
    double? heightBTN,
    Function()? onPressed,
    Color? colorBorder = Colors.greenAccent,
    double? widthBorder = 2,
    Color? colorBackGround,
    Color? labelColor = Colors.greenAccent,
    TextAlign? textAlignLabel = TextAlign.center,
    double? borderRadius = 5,
  }) {
    return XBtnbase.onlyBorderAndLabel(
      widthBTN: widthBTN,
      heightBTN: heightBTN,
      labelColor: labelColor,
      colorBorder: colorBorder,
      onPressed: onPressed,
      colorBackGround: colorBackGround,
      label: label,
    );
  }

  @override
  Widget build(BuildContext context) {
    return Tooltip(
        preferBelow: true,
        message: toolTip_Message ?? "",
        child: Container(
            width: (label != "" || width != null) ? width : 40,
            height: (label != "" || height != null) ? height : 40,
            margin: margin ?? null,
            alignment: Alignment.center,
            decoration: decoration ?? BoxDecoration(color: backGroundColor, borderRadius: BorderRadius.all(Radius.circular(radiusBorder ?? 0))),
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                elevation: elevation ?? 0,
                backgroundColor: Colors.transparent,
                alignment: Alignment.centerLeft,
                padding: padding ?? EdgeInsets.all(5),
                enableFeedback: enableFeedback,
              ),
              onPressed: nameOfPageToGo != "" ? () => Navigator.pushNamed(context_buildPage!, nameOfPageToGo!) : onPressed,
              child: (icon != null && (label == null || label == ""))
                  ? Container(
                      color: Colors.transparent,
                      alignment: Alignment.center,
                      child: Row(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.center, mainAxisAlignment: MainAxisAlignment.center, children: [
                        Container(
                          color: Colors.transparent,
                          alignment: Alignment.center,
                          child: Icon(icon, color: icon_Color ?? label_Color ?? XColors.foregroundLight, size: icon_Size),
                        )
                      ]))
                  : Row(
                      crossAxisAlignment: CrossAxisAlignment.center,
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        icon_Widget == null
                            ? icon != null
                                ? Container(
                                    color: Colors.transparent,
                                    width: icon_WidthArea ?? 40,
                                    alignment: Alignment.center,
                                    child: Icon(icon, color: icon_Color ?? label_Color ?? XColors.foregroundLight, size: icon_Size),
                                  )
                                : Container()
                            : icon_Widget ?? Container(),
                        label != null
                            ? Expanded(
                                child: Container(
                                    color: Colors.transparent,
                                    alignment: alignmentLabel ?? Alignment.center,
                                    child: Text(
                                      label!,
                                      style: label_Style ?? XStyles.xStyleText(fontSize: 14, colorText: label_Color ?? XColors.foregroundLight),
                                      textAlign: label_TextAlign ?? TextAlign.center,
                                      overflow: TextOverflow.ellipsis,
                                    )))
                            : Container(),
                      ],
                    ),
            )));
  }
}
