part of xwidgetbase;

class XBtnbaseForTheme extends StatelessWidget {
  final String? label;
  final TextStyle? styleLabel;
  final AlignmentGeometry? alignmentLabel;

  ///Da il colore a tutti i tipi di testo
  final Color? textColor;
  final IconData? icon;
  final Color? iconColor;
  final double? iconSize;

  final double? widthBTN;
  final double? heightBTN;
  final Color? colorBTN;
  final Decoration? decorationBTN;
  final double? radiusBorder;
  final double? elevation;
  final double? widthAreaOfIcon;
  final EdgeInsets? paddingBTNContent;
  final EdgeInsets? marginBTN;
  final bool? enableFeedback;

  final String? nameOfPageToGo;
  final BuildContext? buildContextOfPage;
  final Function()? onPressed;
  final TextAlign? textAlignLabel;
  final Widget? iconWidget;
  final OutlinedBorder? shape;

  XBtnbaseForTheme({
    this.label = "",
    this.decorationBTN,
    this.iconWidget,
    this.shape,
    this.enableFeedback = true,
    this.paddingBTNContent,
    this.marginBTN,
    this.radiusBorder,
    this.widthBTN = 100,
    this.heightBTN = 50,
    this.alignmentLabel,
    this.elevation,
    this.buildContextOfPage,
    this.icon,
    this.textAlignLabel,
    this.nameOfPageToGo = "",
    this.styleLabel,
    this.iconSize = 28,
    this.colorBTN,
    this.textColor,
    this.iconColor = Colors.black,
    this.onPressed,
    this.widthAreaOfIcon,
  });

  static onlyBorderAndLabel({
    String? label,
    double? widthBTN = 250,
    double? heightBTN = 40,
    Function()? onPressed,
    Color? colorBorder,
    double? widthBorder = 2,
    Color? colorBackGround,
    Color? iconColor,
    double? iconSize,
    Color? labelColor,
    TextAlign? textAlignLabel = TextAlign.center,
    double? borderRadius = 5,
    IconData? icon,
    EdgeInsets? marginBTN,
  }) {
    return XBtnbaseForTheme(
      elevation: 0,
      widthBTN: widthBTN,
      marginBTN: marginBTN,
      heightBTN: heightBTN,
      textAlignLabel: textAlignLabel,
      label: icon != null ? null : label,
      iconColor: colorBorder,
      icon: (icon != null && (label == null || label == "")) ? icon : null,
      colorBTN: Colors.transparent,
      // styleLabel: XStyles.xStyTextForLabel(labelColor ?? colorBorder),
      decorationBTN: BoxDecoration(
          borderRadius: BorderRadius.all(Radius.circular(10)),
          color: colorBackGround,
          border: Border.all(
            color: colorBorder!,
            width: widthBorder!,
          )),
      onPressed: onPressed,
    );
  }

  static ForMenu({
    String? label = "Inserisci Label",
    double? widthBTN = 250,
    double? heightBTN = 50,
    Function()? onPressed,
    Color? colorBorder = Colors.greenAccent,
    double? widthBorder = 2,
    Color? colorBackGround,
    Color? labelColor = Colors.greenAccent,
    TextAlign? textAlignLabel = TextAlign.center,
    double? borderRadius = 5,
  }) {
    return XBtnbaseForTheme.onlyBorderAndLabel(
      widthBTN: 250,
      heightBTN: heightBTN,
      labelColor: labelColor,
      colorBorder: colorBorder,
      onPressed: onPressed,
      colorBackGround: colorBackGround,
      label: label,
    );
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        width: widthBTN,
        // color: decorationBTN != null ? null : colorBTN ?? null,
        height: heightBTN,
        margin: marginBTN,
        alignment: Alignment.center,
        decoration: decorationBTN ?? BoxDecoration(color: colorBTN, borderRadius: BorderRadius.all(Radius.circular(radiusBorder ?? 0))),
        child: ElevatedButton(
          style: ElevatedButton.styleFrom(
            foregroundColor: textColor,
            backgroundColor: colorBTN,
            shape: shape,
            elevation: elevation ?? 10,
            alignment: Alignment.centerLeft,
            padding: paddingBTNContent ?? EdgeInsets.all(5),
            enableFeedback: enableFeedback,
          ),
          onPressed: nameOfPageToGo != ""
              ? () {
                  Navigator.pushNamed(buildContextOfPage!, nameOfPageToGo!);
                }
              : onPressed,
          child: (icon != null && (label == null || label == ""))
              ? Container(
                  alignment: Alignment.center,
                  // color: Colors.transparent,
                  // height: heightBTN!,
                  // width: widthBTN!,
                  child: Row(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.center, mainAxisAlignment: MainAxisAlignment.center, children: [
                    Container(
                      // color: Colors.transparent,
                      alignment: Alignment.center,
                      child: Icon(
                        icon,
                        color: iconColor,
                        size: iconSize,
                      ),
                    ),
                  ]))
              : Row(
                  crossAxisAlignment: CrossAxisAlignment.center,
                  children: [
                    iconWidget == null
                        ? icon != null
                            ? Container(
                                // color: Colors.transparent,
                                width: widthAreaOfIcon ?? null,
                                alignment: Alignment.center,
                                child: Icon(
                                  icon,
                                  color: iconColor,
                                  size: iconSize,
                                ))
                            : Container()
                        : iconWidget ?? Container(),
                    label != null
                        ? Expanded(
                            child: Container(
                                // color: Colors.transparent,
                                alignment: alignmentLabel ?? Alignment.center,
                                child: FittedBox(
                                    fit: BoxFit.scaleDown,
                                    child: Text(
                                      label!,
                                      style: styleLabel ?? XStyles.xStyleText(fontSize: 13, colorText: textColor),
                                      textAlign: textAlignLabel ?? TextAlign.center,
                                    ))))
                        : Container(),
                  ],
                ),
        ));
  }
}
