part of xwidgetbase;

class XItem extends StatelessWidget {
  final bool title_OnTop;
  final String? title;
  final Color? title_Color;
  final Color? title_BorderColor;
  final TextStyle? title_Style;

  ///Modificherai il widget dentro il TitleContainer senza toccare il widget che fa da contenitore
  final Widget? title_Widget;
  final TextAlign title_TextAlign;
  final double title_ContainerWidth;
  final double? title_ContainerHeight;

  ///Allineamento del Title solo se la Label è sopra
  final AlignmentGeometry? title_AlignOnTop;

  ///Allineamento del Title solo se la Label è a sinistra
  final AlignmentGeometry? title_AlignOnLeft;
  final Color? title_BackGroundColor;
  final double? title_WidthBorder;
  final Color? card_Color;

  ///Allineamento orizzontale dell'XItem
  final CrossAxisAlignment? crossAxisAlignmentXItem;

  ///Allineamento Verticale dell'XItem
  final MainAxisAlignment? mainAxisAlignmentXItem;
  final List<Widget>? children;
  // final bool visibleBottomBorderOfCard;
  final CrossAxisAlignment? childrens_CrossAxisAlignment;
  final BoxConstraints? constraints;
  final Axis? wrap_Direction;
  final double? wrap_Spacing;
  final double? wrap_RunSpacing;
  final double? wrap_Height;
  final double? width;

  final double? wrap_Width;
  final Decoration? decorationForListContainer;

  ///Utilizzato principalmente su APP
  final Function()? onTap;
  XItem({
    Key? key,
    this.onTap,
    this.width,
    this.decorationForListContainer,
    this.wrap_Spacing,
    this.wrap_Width,
    this.wrap_Height,
    this.wrap_RunSpacing,
    this.wrap_Direction,
    this.title_AlignOnTop,
    this.mainAxisAlignmentXItem,
    this.title_Widget,
    this.crossAxisAlignmentXItem,
    this.card_Color,
    this.title_Style,
    this.title_AlignOnLeft,
    // this.visibleBottomBorderOfCard__ = false,
    this.title_Color,
    this.title_BorderColor,
    this.title = "",
    this.title_ContainerWidth = 150,
    this.title_ContainerHeight,
    this.children,
    this.title_OnTop = false,
    this.title_TextAlign = TextAlign.center,
    this.title_BackGroundColor,
    this.title_WidthBorder,
    this.childrens_CrossAxisAlignment,
    this.constraints,
    double? height,
    BoxConstraints? constraintsOfXItem,
  });

  static Widget? Three_ConcatenatedXItem<T, K>({
    ///WrapDirection dell'Item principale (Padre)
    required Axis wrapDirection,

    ///fontSize testi dell'Item principale (Padre)
    required double fontSizeForItem,

    ///Titolo dell'Item principale (Padre)
    required String title,

    ///Colore del titolo dell'Item principale (Padre)
    required Color? titleColor,

    ///Prima lista di Items che conterrà l'Item principale (Padre)
    required Iterable<MapEntry<dynamic, List<T>>> items,

    ///Widget per il titolo degli Items della prima lista
    required Widget Function(T) titleFirstWidget,

    ///Raggruppamento per ...., da mettere la propietà o le propietà per fare il groupBy per la seconda lista
    required K Function(T) secondGroupListsBy,

    ///Widget per il titolo degli Items della seconda lista
    required dynamic Function(T) titleSecondWidget,

    ///Widget per la visualizzazione delle Items finali della terza lista
    required Widget Function(T) thirdWidget,

    ///Da settare true nel caso si voglia un groupBy anche per la terza lista
    bool groupByForLastLevel = false,

    ///Raggruppamento per ...., da mettere la propietà o le propietà per fare il groupBy per la terza lista
    K Function(T)? groupListsBy_LastItems,

    ///Widget da riempire nel caso la propietà groupByForLastLevel sia true
    Widget Function(MapEntry<K, List<T>>)? thirdWidgetForGroupBy,
    bool titleFirstOnTop = true,
    bool titleSecondOnTop = false,
    bool? borderAllAroundList,
    Color? backGroundColorTitleContainer,
    Color? backGroundColor,
    Color? backGroundColorFirstXItem,
    Color? backGroundColorSecondXItem,
    Color? colorBorderOfarea,
    Color? colorBorderOfFirstWidget,
    Color? titleBorderColor,

    ///Larghezza dell'XItem Principale (Padre)
    double? width,

    ///Altezza dell'XItem Principale (Padre)
    double? height,
    double? titleContainerHeight,
    double? fontSizeForTitleOfArea,
    double? widthFirstXItem,
    double? widthSecondXItem,
    double? titleFirstContainerWidth,
    double? titleSecondContainerWidth,
    Axis? firstWrapDirection,
    Axis? secondWrapDirection,
    Axis? thirdWrapDirection,
  }) {
    var xi = XItem(title: title, title_Color: titleColor ?? colorBorderOfarea ?? Colors.white, title_OnTop: true, title_BackGroundColor: backGroundColorTitleContainer ?? null, title_ContainerHeight: titleContainerHeight ?? 40, title_WidthBorder: 5, width: width, title_AlignOnTop: Alignment.center, title_ContainerWidth: double.infinity, title_Style: TextStyle(color: titleColor, fontSize: fontSizeForTitleOfArea ?? 24, fontWeight: FontWeight.bold), card_Color: backGroundColor, title_BorderColor: titleBorderColor, children: [
      items.length == 0
          ? XContainer(
              borderWidth: 5,
              title_BackColor: colorBorderOfarea ?? Colors.black,
              borderAll: borderAllAroundList ?? true,
              child: Container(
                height: 100,
                child: Row(children: [Expanded(child: Text("..nessuna..", textAlign: TextAlign.center, style: XStyles.xStyleText(fontSize: 30)))]),
              ))
          : XContainer(
              alignmentChild: Alignment.topLeft,
              heightChildContainer: height,
              borderWidth: 5,
              title_BackColor: colorBorderOfarea ?? Colors.black,
              child: Wrap(
                  spacing: 1,
                  runSpacing: 6,
                  direction: wrapDirection,
                  //1ST GRP
                  children: items.map((grp1) {
                    var xii = XItem(
                        wrap_Direction: firstWrapDirection ?? Axis.vertical,
                        width: widthFirstXItem,
                        height: null,
                        wrap_Spacing: 1,
                        wrap_RunSpacing: 1,
                        title_Widget: grp1.value.map(titleFirstWidget).first,
                        card_Color: backGroundColorFirstXItem ?? Colors.blue.withOpacity(0.2),
                        crossAxisAlignmentXItem: CrossAxisAlignment.start,
                        mainAxisAlignmentXItem: MainAxisAlignment.start,
                        title_AlignOnTop: titleFirstOnTop != false ? Alignment.centerLeft : null,
                        title_ContainerWidth: titleFirstOnTop != false ? double.infinity - 20 : titleFirstContainerWidth ?? 80,
                        title_OnTop: titleFirstOnTop,
                        title_Style: TextStyle(color: colorBorderOfarea ?? titleColor, fontSize: 20),
                        // 2nd GROUP
                        children: grp1.value.groupListsBy<K>(secondGroupListsBy).entries.map((grp2) {
                          return Container(
                              child: XItem(
                            wrap_Direction: secondWrapDirection ?? Axis.horizontal,
                            width: widthSecondXItem,
                            title_Widget: grp2.value.map(titleSecondWidget).first,
                            title_Color: XColors.foregroundLight,
                            title_AlignOnTop: titleSecondOnTop != false ? Alignment.centerLeft : null,
                            title_ContainerWidth: titleSecondOnTop == false ? titleSecondContainerWidth ?? 50 : double.infinity - 20,
                            title_OnTop: titleSecondOnTop,
                            title_BackGroundColor: Colors.transparent,
                            card_Color: backGroundColorSecondXItem,
                            // 3th GROUP
                            children: [
                              XContainer(
                                  title: "",
                                  borderAll: true,
                                  title_BackColor: colorBorderOfFirstWidget != null ? colorBorderOfFirstWidget : Colors.transparent,
                                  backGroundColorInternalWidget: Colors.transparent,
                                  child: Wrap(
                                    direction: thirdWrapDirection ?? Axis.horizontal,
                                    children: groupByForLastLevel == false
                                        ? grp2.value.map(thirdWidget).toList()
                                        : //
                                        grp2.value.groupListsBy<K>(groupListsBy_LastItems!).entries.map(thirdWidgetForGroupBy!).toList(),
                                  )),
                            ],
                          ));
                        }).toList());
                    return xii;
                  }).toList())),
    ]);
    return xi;
  }

  static Widget One_ConcatenatedXItem<T>({
    ///fontSize testi dell'Item principale (Padre)
    required double fontSizeForItem,

    ///Titolo dell'Item principale (Padre)
    required String title,

    ///Colore del titolo dell'Item principale (Padre)
    required Color? titleColor,

    ///Prima lista di Items che conterrà l'Item principale (Padre)
    required List<T> items,

    ///Widget per la visualizzazione per gli items della lista
    required Widget Function(T) widgetItemInList,

    ///Altezza dell'XItem
    double? height,
    double? fontSizeForTitleOfArea,
    Axis? wrapDirectionForList,
    bool titleOnTop = true,
    bool borderAllAroundList = true,
    Color? backGroundColorTitleContainer,
    Color? backGroundColor,
    Color? titleBorderColor,
    double? titleContainerHeight,
    double? titleContainerWidth,
    AlignmentGeometry? titleAlignOnTop,
    AlignmentGeometry? titleAlignOnLeft,
    AlignmentGeometry? alignmentChild,
  }) {
    return XItem(title: title, title_Color: titleColor, title_OnTop: titleOnTop, card_Color: backGroundColor, title_WidthBorder: 5, title_BorderColor: titleBorderColor ?? titleColor ?? Colors.black, title_BackGroundColor: backGroundColorTitleContainer ?? Colors.black, title_AlignOnTop: titleAlignOnTop ?? Alignment.center, title_AlignOnLeft: titleAlignOnLeft ?? Alignment.centerLeft, title_ContainerHeight: titleContainerHeight ?? 40, title_Style: TextStyle(color: titleColor, fontSize: fontSizeForTitleOfArea, fontWeight: FontWeight.bold), title_ContainerWidth: titleOnTop == true ? double.infinity : titleContainerWidth ?? 40, children: [
      items.length == 0
          // NESSUNA - VUOTO
          ? XContainer(
              borderWidth: 5,
              title: "",
              title_BackColor: titleBorderColor ?? Colors.black,
              borderAll: borderAllAroundList,
              child: Container(
                height: 100,
                child: Row(children: [
                  Expanded(child: Text("..nessuna..", textAlign: TextAlign.center, style: XStyles.xStyleText(fontSize: 30))),
                ]),
              ))
          // ITEMS
          : XContainer(
              heightChildContainer: height,
              borderWidth: 5,
              title: "",
              alignmentChild: alignmentChild ?? Alignment.topCenter,
              title_BackColor: titleColor,
              child: Wrap(
                spacing: 2,
                runSpacing: 2,
                direction: wrapDirectionForList ?? Axis.horizontal,
                //LIST
                children: items
                    .map(
                        //ITEM
                        widgetItemInList
                        //ITEM
                        )
                    .toList(),
              ))
    ]);
  }

  static Widget Two_ConcatenatedXItem<T, K>({
    required Axis wrapDirection,

    ///fontSize testi dell'Item principale (Padre)
    required double fontSizeForItem,

    ///Titolo dell'Item principale (Padre)

    ///Colore del titolo dell'Item principale (Padre)
    required Color? titleColor,

    ///Prima lista di Items che conterrà l'Item principale (Padre)
    required Iterable<MapEntry<dynamic, List<T>>> items,

    ///Widget per il titolo degli Items della prima lista
    required Widget Function(T) titleFirstWidget,

    ///Raggruppamento per ...., da mettere la propietà o le propietà per fare il groupBy per la terza lista
    required K Function(T) lastGroupListsBy,

    ///Widget da riempire per visualizzare gli items della seconda lista
    required Widget Function(MapEntry<K, List<T>>) lastWidgetForGroupBy,
    required Widget Function(T) lastWidget,

    ///Da settare false nel caso non si voglia un groupBy anche per l'ultima lista
    bool groupByForLastLevel = true,
    String? title,
    AlignmentGeometry? titleAlignOnTop,
    AlignmentGeometry? titleAlignOnLeft,
    CrossAxisAlignment? crossAxisAlignmentXItem,
    bool titleOnTop = true,
    bool titleFirstOnTop = true,
    bool? borderAllAroundList,
    bool? borderVisible,
    Color? backGroundColorTitleContainer,
    Color? colorBorderOfarea,
    Color? titleBorderColor,
    Color? firstBorderColorOfArea,
    Color? backGroundColor,
    Color? backGroundColorFirstXItem,
    Color? backGroundColorSecondXItem,
    Color? backGroundColorInternalXContainer,
    double? titleContainerHeight,
    double? titleContainerWidth,
    double? fontSizeForTitleOfArea,
    double? widthFirstXItem,
    double? widthSecondXItem,
    double? titleFirstContainerWidth,
    double? titleFirstContainerHeight,
    Axis? firstWrapDirection,
    Axis? secondWrapDirection,
    Axis? thirdWrapDirection,
  }) {
    return XItem(title: title, title_Color: colorBorderOfarea ?? Colors.black, title_OnTop: titleOnTop, title_BorderColor: titleBorderColor ?? Colors.black, title_ContainerHeight: titleContainerHeight, card_Color: backGroundColor ?? Colors.black, title_WidthBorder: 5, title_BackGroundColor: backGroundColorTitleContainer ?? null, mainAxisAlignmentXItem: MainAxisAlignment.start, title_ContainerWidth: titleContainerWidth ?? double.infinity, title_AlignOnTop: titleAlignOnTop ?? Alignment.center, title_AlignOnLeft: titleAlignOnLeft ?? Alignment.center, title_Style: TextStyle(color: titleColor, fontSize: fontSizeForTitleOfArea, fontWeight: FontWeight.bold), children: [
      items.length == 0
          // NESSUNA - VUOTO
          ? XContainer(borderVisible: borderVisible ?? true, title: "", title_BackColor: colorBorderOfarea ?? Colors.black, borderAll: true, child: Container(height: 40, child: Row(children: [Expanded(child: Text("...nessuno...", textAlign: TextAlign.center, style: XStyles.xStyleText(fontSize: 30)))])))
          // ITEMS
          : XContainer(
              borderVisible: borderVisible ?? true,
              borderWidth: 5,
              backGroundColorInternalWidget: backGroundColorInternalXContainer ?? Colors.grey[900],
              title: "",
              title_BackColor: colorBorderOfarea ?? Colors.black,
              child: Wrap(
                  spacing: 1,
                  runSpacing: 1,
                  direction: Axis.horizontal,

                  //1ST GROUP
                  children: items
                      .map((grp) => XItem(
                            title_Widget: grp.value.map(titleFirstWidget).first,
                            //                         crossAxisAlignmentXItem: CrossAxisAlignment.start,
                            crossAxisAlignmentXItem: crossAxisAlignmentXItem ?? CrossAxisAlignment.center,
                            title_AlignOnTop: Alignment.center,
                            title_BackGroundColor: backGroundColorTitleContainer,
                            title_ContainerWidth: titleFirstOnTop == true ? titleFirstContainerWidth ?? 250 : titleFirstContainerWidth ?? 200,
                            title_OnTop: titleFirstOnTop,
                            title_ContainerHeight: titleFirstContainerHeight,
                            width: widthFirstXItem,
                            children: [
                              ///Widget che visualizza Wrapped la lista delle Navi
                              XContainer(
                                  title: "",
                                  borderAll: true,

                                  // backGroundColorInternalWidget: Colors.black,
                                  title_BackColor: firstBorderColorOfArea ?? titleColor,
                                  child: Wrap(
                                      spacing: 1,
                                      runSpacing: 1,
                                      direction: Axis.horizontal,
                                      // 2nd GROUP LIST
                                      children: groupByForLastLevel == true
                                          ? grp.value
                                              .groupListsBy<K>(lastGroupListsBy)
                                              .entries
                                              .map(
                                                //ITEM
                                                lastWidgetForGroupBy,
                                                //ITEM
                                              )
                                              .toList()
                                          : grp.value.map(lastWidget).toList()))
                            ],
                          ))
                      .toList())),
    ]);
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: onTap,
        child: ConstrainedBox(
          constraints: constraints ?? BoxConstraints(),
          child: Container(
            width: width,
            child: Card(
              color: card_Color ?? Colors.transparent,
              child: Container(
                  // decoration: visibleBottomBorderOfCard == true ? BoxDecoration(border: Border(bottom: BorderSide(width: 6, color: Colors.blue.withOpacity(0.5)))) : null,
                  child: Column(
                mainAxisSize: MainAxisSize.min,
                mainAxisAlignment: mainAxisAlignmentXItem ?? MainAxisAlignment.center,
                crossAxisAlignment: crossAxisAlignmentXItem ?? CrossAxisAlignment.center,
                children: [
                  !title_OnTop || title == null
                      ? Container()
                      : Container(
                          alignment: title_AlignOnTop ?? Alignment.center,
                          width: title_ContainerWidth,
                          height: title_ContainerHeight,
                          color: title_BackGroundColor != null ? null : title_BackGroundColor ?? Colors.transparent,
                          margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                          decoration: title_BackGroundColor != null
                              ? BoxDecoration(
                                  color: title_BackGroundColor ?? Colors.transparent,
                                  border: Border(
                                    top: BorderSide(color: title_BorderColor ?? Colors.transparent, width: title_WidthBorder ?? 2),
                                    left: BorderSide(color: title_BorderColor ?? Colors.transparent, width: title_WidthBorder ?? 2),
                                    right: BorderSide(color: title_BorderColor ?? Colors.transparent, width: title_WidthBorder ?? 2),
                                    // bottom: BorderSide(color: colortitle ?? Colors.transparent, width: widthBorderTitleContainer ?? 2),
                                  ))
                              : null,
                          child: title_Widget ??
                              Container(
                                alignment: title_AlignOnTop,
                                height: title_ContainerHeight,
                                child: Text(title!, textAlign: title_TextAlign, style: title_Style ?? XStyles.xStyTextForLabel(title_Color)),
                              )),
                  Container(
                    child: Row(children: [
                      title_OnTop || title == null
                          ? Container()
                          : Container(
                              alignment: title_AlignOnLeft ?? Alignment.center,
                              width: title_ContainerWidth,
                              height: title_ContainerHeight,
                              padding: EdgeInsets.symmetric(vertical: 2),
                              color: title_BackGroundColor ?? Colors.transparent,
                              margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                              child: title_Widget ??
                                  Container(
                                    height: title_ContainerHeight,
                                    child: Text(
                                      title!,
                                      textAlign: title_TextAlign,
                                      style: title_Style ?? XStyles.xStyTextForLabel(title_Color),
                                    ),
                                  )),
                      Flexible(
                          child: Container(
                              decoration: decorationForListContainer,
                              child: Wrap(
                                crossAxisAlignment: WrapCrossAlignment.center,
                                direction: wrap_Direction ?? Axis.horizontal,
                                spacing: wrap_Spacing ?? 5,
                                runSpacing: wrap_RunSpacing ?? 5,
                                children: children!,
                              )))
                    ]),
                  )
                ],
              )),
            ),
          ),
        ));
  }
}
