part of xwidgetbase;

class XTextFormFieldWithContainer extends StatelessWidget {
  final String? label;
  final IconData? icon;
  final Function()? onPressed;
  final ValueChanged<String>? onChanged;
  final FocusNode? focusNode;
  final dynamic initialValue;
  final TextEditingController? controller;
  final TextInputType? keyboardType;
  final Function(String)? onFieldSubmitted;
  final FormFieldValidator<String>? validator;
  final String? hintText;
  final List<TextInputFormatter>? inputFormatters;
  final GestureTapCallback? onTap;
  TextAlign? textAlign = TextAlign.start;
  InputDecoration? decoration = const InputDecoration();

  XTextFormFieldWithContainer({
    this.label,
    this.controller,
    this.textAlign,
    this.icon,
    this.onTap,
    this.validator,
    this.decoration,
    this.onChanged,
    this.inputFormatters,
    this.onFieldSubmitted,
    this.onPressed,
    this.keyboardType,
    this.initialValue,
    this.focusNode,
    this.hintText = '',
  });
  // TextStyle styTextBaseBlack([Color? textColor]) {
  //   if (textColor == null) textColor = Colors.black;
  //   return TextStyle(fontSize: 14, color: textColor);
  // }

  // TextStyle styTitleText1White([Color? textColor]) {
  //   if (textColor == null) textColor = Colors.white;
  //   var s = styTitleText1(textColor);
  //   return s;
  // }

  // TextStyle styTitleText1([Color? textColor]) {
  //   if (textColor == null) textColor = Colors.black;
  //   return TextStyle(fontSize: 17, color: textColor);
  // }

  @override
  Widget build(BuildContext context) {
    return Row(mainAxisAlignment: MainAxisAlignment.center, children: <Widget>[
      Expanded(
          child: Container(
        height: 50,
        width: 150,
        child: Column(
          mainAxisAlignment: MainAxisAlignment.spaceAround,
          children: <Widget>[
            Visibility(
              visible: label != null,
              child: Text(
                label ?? " ",
                style: XStyles.xStyTextForLabel(),
              ),
            ),
            Expanded(
                child: Container(
                    alignment: Alignment.center,
                    child: TextFormField(
                        onFieldSubmitted: onFieldSubmitted!,
                        onTap: onTap,
                        inputFormatters: inputFormatters,
                        textAlign: textAlign ?? TextAlign.start,
                        controller: controller,
                        onChanged: onChanged,
                        validator: validator,
                        keyboardType: keyboardType,
                        initialValue: initialValue,
                        decoration: InputDecoration(
                          hintText: hintText,
                        ),
                        style: XStyles.xStyleText(fontSize: 17)))),
          ],
        ),
      ))
    ]);
  }
}
