part of xwidgetbase;

class XAlertDialog extends StatelessWidget {
  String? title_Text;
  Function()? btnYES_OnPressed;
  Function()? btnNO_OnPressed;
  String? btnYES_label;
  String? btnNO_label;
  Color? btnYES_Labelcolor;
  Color? btnNO_Labelcolor;
  Color? colorBackGround;
  EdgeInsets? content_insetPadding;
  TextStyle? content_TextStyle;

  ///Widget che viene messo sotto il title dell'alert e  sopra l'area dei bottoni in basso
  Widget? child;
  double? height;
  final TextStyle? title_Style;
  final double? actionsBTNarea_Height;

  ///Inseriscici tutti i widget che vuoi che verranno visualizzati in basso
  final Widget? actionsBTNarea_Child;
  final EdgeInsetsGeometry? actionsBTNarea_Padding;
  final Widget? title_Widget;
  final TextAlign? title_TextAlign;
  XAlertDialog({
    this.title_Text,
    this.title_Style,
    this.content_insetPadding,
    this.content_TextStyle,
    this.btnYES_OnPressed,
    this.btnNO_OnPressed,
    this.actionsBTNarea_Height = 40,
    this.actionsBTNarea_Padding,
    this.actionsBTNarea_Child,
    this.btnYES_label,
    this.height,
    this.btnNO_label,
    this.btnYES_Labelcolor,
    this.btnNO_Labelcolor,
    this.child,
    this.colorBackGround,
    this.title_Widget,
    this.title_TextAlign,
  });

  ///Alert per il trona insietro senza aver salvato
  static alertDialogForPop(BuildContext context, Function()? onPressedYes) {
    return showDialog(
        context: context,
        builder: (context) {
          return XAlertDialog(
            height: 35,
            title_Style: XStyles.xStyTextForSubLabel(),
            title_Text: "Vuoi annullare le modifiche fatte?",
            btnYES_label: "SI",
            btnNO_label: "NO",
            btnYES_Labelcolor: Colors.greenAccent,
            btnNO_Labelcolor: Colors.redAccent,
            btnYES_OnPressed: () {
              Navigator.pop(context);
              onPressedYes?.call();
            },
            btnNO_OnPressed: () {
              Navigator.pop(context);
            },
          );
        });
  }

  static alertClose(
    BuildContext context, {
    String titleText = "",
    TextStyle? titleStyle,
    Color? titleColor,
    String? labelBTNtext,
    TextStyle? labelBTNstyle,
    Color? labelBTNcolor,
    Decoration? decorationBTN,
    Color? colorBTN,
  }) {
    return showDialog(
        context: context,
        builder: (context) {
          return XAlertDialog(
              height: null,
              title_Text: titleText,
              title_Style: titleStyle ?? XStyles.xStyTextForTextBase(titleColor ?? Colors.white),
              actionsBTNarea_Child: Row(mainAxisAlignment: MainAxisAlignment.end, children: [
                XBtnbase(
                    width: 120,
                    height: 40,
                    label: labelBTNtext ?? "CHIUDI",
                    label_Style: labelBTNstyle ?? XStyles.xStyTextForSubLabel(labelBTNcolor ?? Colors.greenAccent),
                    decoration: decorationBTN ?? BoxDecoration(color: colorBTN ?? Colors.transparent),
                    elevation: 0,
                    onPressed: () {
                      Navigator.pop(context);
                    })
              ]));
        });
  }

  static alertYesNo(
    BuildContext context,
    Function()? onPressedBTN_YES, {
    String titleText = "",
    TextStyle? titleStyle,
    Color? titleColor,
    String? labelBTNtext,
    TextStyle? styleLabelBTN_NO,
    TextStyle? styleLabelBTN_YES,
    Color? colorLabelBTN_NO,
    Color? colorLabelBTN_YES,
    Decoration? decorationBTN,
    Color? colorBTN,
    double? heightBTN,
    double? widthBTN,
  }) {
    return showDialog(
        context: context,
        builder: (context) {
          return XAlertDialog(
              height: null,
              title_Text: titleText,
              title_Style: titleStyle ?? XStyles.xStyTextForTextBase(titleColor ?? Colors.white),
              actionsBTNarea_Child: Row(mainAxisAlignment: MainAxisAlignment.spaceAround, children: [
                XBtnbase(
                    width: widthBTN ?? 70,
                    height: heightBTN ?? 30,
                    label: labelBTNtext ?? "NO",
                    label_Style: styleLabelBTN_NO ?? XStyles.xStyTextForSubLabel(colorLabelBTN_NO ?? Colors.redAccent),
                    decoration: decorationBTN ?? BoxDecoration(color: colorBTN ?? Colors.transparent),
                    elevation: 0,
                    onPressed: () {
                      Navigator.pop(context);
                    }),
                XBtnbase(
                    width: widthBTN ?? 70,
                    height: heightBTN ?? 30,
                    label: labelBTNtext ?? "SI",
                    label_Style: styleLabelBTN_YES ?? XStyles.xStyTextForSubLabel(colorLabelBTN_YES ?? Colors.greenAccent),
                    decoration: decorationBTN ?? BoxDecoration(color: colorBTN ?? Colors.transparent),
                    elevation: 0,
                    onPressed: () {
                      onPressedBTN_YES!();
                      Navigator.pop(context);
                    })
              ]));
        });
  }

  @override
  Widget build(BuildContext context) {
    return AlertDialog(
      contentTextStyle: content_TextStyle,
      insetPadding: content_insetPadding ?? EdgeInsets.symmetric(horizontal: 40.0, vertical: 24.0),
      contentPadding: actionsBTNarea_Padding ?? EdgeInsets.fromLTRB(24.0, 20.0, 24.0, 10.0),
      backgroundColor: colorBackGround,
      title: title_Widget ??
          Column(children: [
            title_Text != null ? Text(title_Text ?? 'Hai cambiato dei dati cosa vuoi fare?', style: title_Style ?? XStyles.xStyleText(fontSize: 19), textAlign: title_TextAlign ?? TextAlign.left) : Text(title_Text ?? "", textAlign: title_TextAlign ?? TextAlign.left),
          ]),
      content: child != null ? (height != null ? Container(height: height, child: child) : child!) : Container(height: 1),
      actions: [
        actionsBTNarea_Child ??
            Container(
                height: actionsBTNarea_Height ?? null,
                child: Row(mainAxisAlignment: MainAxisAlignment.spaceAround, children: [
                  Expanded(child: Container(child: TextButton(onPressed: btnNO_OnPressed, child: Text(btnNO_label ?? "NON LI SALVO", style: TextStyle(color: btnNO_Labelcolor ?? Colors.redAccent, fontSize: 18))))),
                  Expanded(child: Container(child: TextButton(onPressed: btnYES_OnPressed, child: Text(btnYES_label ?? "LI SALVO", style: TextStyle(color: btnYES_Labelcolor ?? Colors.greenAccent, fontSize: 18))))),
                ])),
      ],
    );
  }
}
