part of xwidgetbase;

class XDashboardCard extends StatelessWidget {
  final dynamic itemToView;
  final String propToShow;
  final IconData? icon;
  final String? messageForError;
  final double? widthCard;
  final double? heightCard;
  final double? iconSize;
  final TextStyle? styleLabel;
  final bool horizontalCard;
  final Color? iconColor;
  XDashboardCard({
    Key? key,
    this.itemToView,
    this.iconColor,
    this.horizontalCard = false,
    this.propToShow = "",
    this.messageForError = "",
    this.icon,
    this.iconSize,
    this.styleLabel,
    this.widthCard,
    this.heightCard,
  });

  @override
  Widget build(BuildContext context) {
    return Container(
        width: widthCard ?? null,
        height: heightCard ?? null,
        child: horizontalCard
            ? Row(
                children: [
                  icon == null
                      ? Container()
                      : Expanded(
                          child: Container(
                              child: Icon(
                          icon ?? Icons.directions_boat_outlined,
                          size: iconSize ?? 40,
                          color: iconColor ?? Colors.black,
                        ))),
                  Expanded(flex: 3, child: Container(alignment: Alignment.center, child: Text(itemToView ?? messageForError ?? "<No Data>", style: styleLabel ?? XStyles.xStyTextForLargeTitle(), textAlign: TextAlign.center))),
                ],
              )
            : Column(
                mainAxisAlignment: MainAxisAlignment.spaceAround,
                children: [
                  icon == null ? Container() : Row(mainAxisAlignment: MainAxisAlignment.center, children: [Container(child: Icon(icon ?? Icons.directions_boat_outlined, size: iconSize ?? 40))]),
                  Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                    Expanded(child: Container(child: Text(itemToView ?? messageForError ?? "<No Data>", style: styleLabel ?? XStyles.xStyTextForLargeTitle(), textAlign: TextAlign.center))),
                  ])
                ],
              ));
  }
}
