part of xwidgetbase;

class XAppBar extends StatelessWidget implements PreferredSizeWidget {
  final double? height;
  final bool? centerTitle;
  final String? title;
  final Widget? title_Widget;
  final Color? title_color;
  final double? title_fontSize;
  final double? title_letterSpacing;
  final TextStyle? title_textStyle;
  final Color? backGroundColor;
  final Widget? leading_Widget;
  final double? leading_Width;
  final TextStyle? leading_LabelTextStyle;
  final String? leading_Label;
  final List<Widget>? actions;
  XAppBar({
    this.centerTitle,
    this.height,
    this.title,
    this.title_Widget,
    this.title_color,
    this.title_fontSize,
    this.title_letterSpacing,
    this.title_textStyle,
    this.backGroundColor,
    this.leading_Label,
    this.leading_LabelTextStyle,
    this.leading_Widget,
    this.leading_Width,
    this.actions,
  });

  @override
  Widget build(BuildContext context) {
    return AppBar(
      centerTitle: centerTitle ?? true,
      backgroundColor: backGroundColor,
      title: title_Widget ??
          FittedBox(
              fit: BoxFit.scaleDown,
              child: Container(
                  margin: EdgeInsets.only(right: 10),
                  alignment: Alignment.center,
                  child: Text(
                    title ?? "",
                    style: title_textStyle ?? XStyles.xStyleText(fontSize: title_fontSize, letterSpacing: title_letterSpacing, colorText: title_color),
                  ))),
      leading: leading_Widget ?? (leading_Label != null ? Container(margin: EdgeInsets.only(left: 10), child: FittedBox(child: Text(leading_Label!, style: leading_LabelTextStyle ?? XStyles.xStyTextForLabel()))) : null),
      leadingWidth: leading_Width,
      toolbarHeight: height,
      actions: actions ?? null,
    );
  }

  @override
  Size get preferredSize => Size.fromHeight(height ?? 40);
}
