part of xwidgetbase;

class XDrawer extends StatelessWidget {
  final String? label;
  final GestureTapCallback? logOut_OnTap;
  final GestureTapCallback? nameApp_OnTap;
  final Widget? nameApp;
  final String? title;
  final EdgeInsetsGeometry? padding_nameApp;
  final AlignmentGeometry? alignment;
  final bool? logOut_Visible;
  final Color? menu_BackGroundColor;
  final Color? logOut_BackGroundColor;
  final Widget? logOut_Text;
  final Widget? logOut_Icon;
  final TextStyle? title_Style;
  final Widget? menu_Child;
  XDrawer({
    this.nameApp,
    this.nameApp_OnTap,
    this.menu_Child,
    this.logOut_BackGroundColor,
    this.logOut_Text,
    this.logOut_Icon,
    this.logOut_Visible,
    this.alignment,
    this.menu_BackGroundColor,
    this.label,
    this.title_Style,
    this.title,
    this.padding_nameApp,
    this.logOut_OnTap,
  });

  @override
  Widget build(BuildContext context) {
    return Drawer(
        child: Container(
            color: menu_BackGroundColor ?? Colors.white,
            child: Column(
              children: [
                Expanded(
                    flex: logOut_Visible != false ? 1 : 2,
                    child: SingleChildScrollView(
                        child: Column(mainAxisSize: MainAxisSize.min, children: <Widget>[
                      nameApp != null
                          ? Container(
                              padding: padding_nameApp ?? EdgeInsets.all(50),
                              child: Column(
                                mainAxisSize: MainAxisSize.min,
                                children: <Widget>[nameApp ?? Container()],
                              ))
                          : Container(height: 0, width: 0),
                      Container(
                          padding: EdgeInsets.all(15),
                          child: Column(children: <Widget>[
                            title != ""
                                ? Container(
                                    alignment: Alignment.center,
                                    margin: EdgeInsets.only(bottom: 10),
                                    child: Text(
                                      title ?? "",
                                      style: title_Style ?? XStyles.xStyleText(fontSize: 12, colorText: Colors.black, letterSpacing: 1.5),
                                    ))
                                : Container(),
                            Container(alignment: alignment ?? Alignment.center, child: menu_Child),
                          ])),
                      SizedBox(height: 15),
                    ]))),
                Visibility(
                  visible: logOut_Visible ?? true,
                  child: Expanded(
                    flex: 1,
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.end,
                      children: <Widget>[
                        Container(
                            color: logOut_BackGroundColor ?? Colors.grey,
                            child: ListTile(
                              title: logOut_Text ?? Text('Logout', style: XStyles.xStyleText(fontSize: 17, colorText: Colors.black), textAlign: TextAlign.left),
                              trailing: logOut_Icon ?? Icon(Icons.power_settings_new, color: Colors.red),
                              onTap: logOut_OnTap,
                            )),
                        SizedBox(height: MediaQuery.of(context).padding.bottom)
                      ],
                    ),
                  ),
                ),
              ],
            )));
  }
}
