part of xwidgetbase;

class XCardForText extends StatelessWidget {
  final String? title;
  final String? description;
  final String? imageAssets;
  final double? width;
  final double? height;
  final bool? photoLeft;
  final double? heightPhoto;
  XCardForText({
    this.description,
    this.width,
    this.photoLeft,
    this.heightPhoto,
    this.height,
    this.imageAssets,
    this.title,
  });

  @override
  Widget build(BuildContext context) {
    return Expanded(
        child: Card(
            elevation: 22,
            color: Colors.white.withAlpha(200),
            child: photoLeft == true
                ? Row(
                    children: [
                      Expanded(
                          flex: 1,
                          child: Container(
                            height: heightPhoto,
                            margin: EdgeInsets.all(10),
                            child: Image.asset(
                              imageAssets!,
                              fit: BoxFit.fill,
                            ),
                          )),
                      SizedBox(width: 100),
                      Expanded(
                          flex: 2,
                          child: Column(
                            children: [
                              SizedBox(height: 10),
                              Text(
                                title!,
                                style: TextStyle(
                                  color: Colors.black,
                                  fontSize: 25,
                                ),
                                textAlign: TextAlign.justify,
                              ),
                              SizedBox(height: 10),
                              Container(
                                  margin: EdgeInsets.all(10),
                                  child: Text(
                                    description!,
                                    style: TextStyle(
                                      color: Colors.black,
                                      fontSize: 25,
                                    ),
                                    textAlign: TextAlign.justify,
                                  )),
                            ],
                          )),
                      SizedBox(width: 20),
                    ],
                  )
                : Row(
                    children: [
                      SizedBox(width: 20),
                      Expanded(
                          flex: 2,
                          child: Column(
                            children: [
                              SizedBox(height: 10),
                              Text(
                                title!,
                                style: TextStyle(
                                  color: Colors.black,
                                  fontSize: 25,
                                ),
                              ),
                              SizedBox(height: 10),
                              Container(
                                  margin: EdgeInsets.all(10),
                                  child: Text(
                                    description!,
                                    style: TextStyle(
                                      color: Colors.black,
                                      fontSize: 25,
                                    ),
                                  )),
                            ],
                          )),
                      SizedBox(width: 100),
                      Expanded(
                          flex: 1,
                          child: Container(
                            height: heightPhoto,
                            margin: EdgeInsets.all(10),
                            child: Image.asset(
                              imageAssets!,
                              fit: BoxFit.fill,
                            ),
                          )),
                    ],
                  )));
  }
}
