part of xwidgetbase;

class XContainerWithLabel extends StatelessWidget {
  final String? label;
  final Color? color;
  final Color? label_Color;
  final TextStyle? textStyle;
  final double? height;
  final AlignmentGeometry? alignmentContainer;
  final TextAlign? textAlignment;
  final EdgeInsetsGeometry? margin;
  final EdgeInsetsGeometry? padding;
  final double? maxwidth;
  final Decoration? decoration;
  XContainerWithLabel(
    this.label, {
    this.height,
    this.label_Color,
    this.alignmentContainer,
    this.textAlignment,
    this.maxwidth,
    this.margin,
    this.padding,
    this.decoration,
    this.color = Colors.white,
    this.textStyle,
  });

  TextStyle styTextBaseBlack([Color? textColor]) {
    if (textColor == null) textColor = Colors.black;
    return TextStyle(fontSize: 14, color: textColor);
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: margin ?? EdgeInsets.only(right: 0),
      height: height,
      decoration: decoration ?? null,
      color: decoration != null ? null : color,
      width: maxwidth,
      padding: padding ?? EdgeInsets.symmetric(vertical: 7),
      alignment: alignmentContainer ?? Alignment.center,
      child: Text(label ?? " ", style: textStyle ?? styTextBaseBlack(label_Color), textAlign: textAlignment ?? TextAlign.center),
    );
  }
}
