import 'dart:async';
import 'package:collection/collection.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:xwidgetsbase/XStylesBase.dart';
import 'package:xwidgetsbase/xWidgetsBase.dart';

import 'XF_Col.dart';
import 'XF_DataItem.dart';
import 'XF_View.dart';
import 'Xfx_Scheda.dart';

extension WhereMethod<K> on Iterable<K>? {
  Iterable<K> whereMethod({bool Function(K)? fun}) {
    if (this != null && fun != null) {
      return this!.where(fun);
    } else if (this == null) {
      return [];
    } else {
      return this!.toList();
    }
  }
}

// extension EmptyString on String? {
//   String isEmptyString({String? emptyMessage}) {
//     if (this == null) {
//       return emptyMessage ?? "";
//     } else {
//       return this!;
//     }
//   }
// }

class XElenco<T, K extends XFDataItem> extends StatefulWidget {
  XElenco(
    this.title_Text,
    this.view, {
    Key? key,
    this.viewDetts,
    this.title_OnTop_Visible = false,
    this.headers_Visible,
    this.filters_Visible = false,
    this.heightForHeader,
    this.headers,
    this.filters,
    this.numberOfHeader,
    this.flexForList,
    this.colorBackgroundContainerElTitle,
    this.heightContainerElTitle,
    this.title_Style,
    this.BTNtitle_Label,
    this.BTNtitle_Color,
    this.BTNtitle_OnPressed,
    this.BTNtitle_Height,
    this.BTNtitle_Width,
    this.BTNtitle_Visible = false,
    this.BTNtitle_Margin,
    this.margin_Horizontal,
    this.onRefresh_ScrollDownList,
    this.item_Widget,
    this.floatingActionButton,
    this.searchBar_Active = true,
    this.allowAdd = true,
    this.cmd_Add,
    this.onDoubleTapItem,
    this.pageMode_Active = true,
    this.onTapItem,
    this.schNameToOpen,
    this.formatDate,
    this.liDetts,
    this.xDrawerMenu,
    this.appBar_Color,
    this.searchBar_Color,
    this.searchBar_ColorBorder,
    this.searchBar_ColorHint,
    this.searchBar_ColorIconClear,
    this.searchBar_ColorIconSearch,
    this.searchBar_ColorText,
    this.searchBar_hintText,
    this.searchBar_whereMethod,
    this.onPressed_MENU,
    this.liPopUpMenu_Items,
    this.item_BackGroundColor,
    this.elDettsMode_SchItem,
    this.liDettsSubArea_Widgets,
    this.edited,
    this.xOnReturnBack,
    this.noTextWhenCellValueIsNull = false,
    this.title_Color,
    this.onEditBoolValueOnItem,
    this.liWidgets_LeftArea_Item,
    this.schedaMode = false,
    this.functInItem,
  }) : super(key: key);
  XView? view;
  XView? viewDetts;
  double? margin_Horizontal;
  Future<void> Function(BuildContext)? onRefresh_ScrollDownList;
  Function()? functInItem;
  bool title_OnTop_Visible;
  bool? headers_Visible;
  bool? filters_Visible;
  double? heightForHeader;
  String? formatDate;
  List<Widget>? headers = List<Widget>.empty(growable: true);
  List<Widget>? filters = List<Widget>.empty(growable: true);
  int? numberOfHeader;
  int? flexForList;
  Color? colorBackgroundContainerElTitle;
  double? heightContainerElTitle;
  String title_Text;
  TextStyle? title_Style;
  Color? title_Color;
  String? BTNtitle_Label;
  Color? BTNtitle_Color;
  Function()? BTNtitle_OnPressed;
  double? BTNtitle_Height;
  double? BTNtitle_Width;
  bool? BTNtitle_Visible;
  EdgeInsets? BTNtitle_Margin;
  Widget? Function(K)? item_Widget;
  Color? appBar_Color;
  Widget? floatingActionButton;
  Widget? xDrawerMenu;
  Widget? Function(dynamic)? liDettsSubArea_Widgets;
  Function(void Function(void Function()))? xOnReturnBack;
  bool searchBar_Active;
  Color? searchBar_ColorHint;
  Color? searchBar_ColorText;
  Color? searchBar_ColorIconClear;
  Color? searchBar_ColorIconSearch;
  Color? searchBar_Color;
  Color? searchBar_ColorBorder;
  String? searchBar_hintText;
  List<Widget>? Function(K)? liWidgets_LeftArea_Item;
  bool Function(K, String)? searchBar_whereMethod;
  ValueNotifier<bool>? edited;
  bool allowAdd;
  bool? schedaMode;
  Function(void Function(void Function()))? cmd_Add;
  Function()? onDoubleTapItem;
  Function(K)? onTapItem;
  Function()? onPressed_MENU;
  String? schNameToOpen;
  Function(XCol, bool)? onEditBoolValueOnItem;
  Color? item_BackGroundColor;

  bool noTextWhenCellValueIsNull;
  bool pageMode_Active;
  bool? elDettsMode_SchItem;

  List<XPopUpMenuItem>? liPopUpMenu_Items = List<XPopUpMenuItem>.empty(growable: true);
  List<dynamic>? liDetts;

  @override
  XElencoState<T, K> createState() => XElencoState<T, K>();
}

class XElencoState<T, K extends XFDataItem> extends State<XElenco<T, K>> with SingleTickerProviderStateMixin {
  ScrollController? scroll_controller = ScrollController();
  TextEditingController searchController = TextEditingController();

  late Future<List<K>?> Function()? xLoadData_apiCall = () async => await List<K>.empty(growable: true);
  List<K> list = List<K>.empty(growable: true);

  bool isBusy = false;

  static String filterAll = "TUTTI";
  String filterCurrent = "";
  String? filterValue;
  Timer? timerSearch;

  Animation<double>? _swipingAnimation;
  AnimationController? _swipingAnimationController;

  String waiterMessage = "";

  @override
  void initState() {
    if (widget.edited == null) {
      widget.edited = ValueNotifier(false);
    }
    xLoadDataOnly();
    _swipingAnimationController = AnimationController(duration: const Duration(milliseconds: 200), vsync: this);
    searchController.addListener(
      () {
        setState(() {
          filterValue = searchController.text;
          if (timerSearch != null) timerSearch!.cancel();
          timerSearch = Timer(Duration(milliseconds: 300), timerSearchHandlerList);
        });
      },
    );
    super.initState();
  }

  @override
  void dispose() {
    searchController.dispose();
    if (_swipingAnimationController != null) {
      _swipingAnimationController!.dispose();
      _swipingAnimationController = null;
    }
    super.dispose();
  }

  void rebuildAllChildren(BuildContext context) {
    void rebuild(Element el) {
      el.markNeedsBuild();
      el.visitChildren(rebuild);
    }

    (context as Element).visitChildren(rebuild);
  }

  timerSearchHandlerList() {
    setState(() {
      if (timerSearch != null) timerSearch!.cancel();
      if (filterValue != "") {
        filterCurrent = filterValue.toString();
      } else if (filterValue == "") {
        filterCurrent = "";
      }
    });
  }

  xLoadDataOnly() {
    setState(() {
      isBusy = true;
    });
    if (xLoadData_apiCall == null) {
    } else {
      xLoadData_apiCall!().then((value) {
        list.clear();
        list.addAll(value!);
      }).whenComplete(() {
        setState(() {
          isBusy = false;
        });
      });
    }
  }

  List<Widget> xLayout_WidgetsLeftArea_Item(K item, void Function(void Function()) parentSetState) {
    return widget.liWidgets_LeftArea_Item != null ? widget.liWidgets_LeftArea_Item!(item)! : [];
  }

  xOnTapItem(K item) async {}

  Widget? xLayout_DettItemWidget(dynamic item) {
    if (widget.liDettsSubArea_Widgets != null) {
      return widget.liDettsSubArea_Widgets!(item);
    } else {
      return null;
    }
  }

  Widget xLayout_CheckBox_Widget(bool value, XCol xCol) {
    return Checkbox(
        value: value,
        onChanged: (value) {
          setState(() {
            value = value;
            widget.edited!.value = true;
            widget.onEditBoolValueOnItem!(xCol, value ?? false);
          });
        });
  }

  Widget? xLayout_ItemWidget(K item) {
    return widget.schedaMode == true
        ? XElencoItem(item, widget.view!,
            funct: widget.functInItem,
            showingDetails: item.isShowDetails,
            margin: EdgeInsets.symmetric(vertical: 2),
            backGroundColor_ChildMain: (item.isShowDetails ? Colors.grey[900] : widget.item_BackGroundColor ?? (widget.appBar_Color == null ? widget.item_BackGroundColor ?? Color.fromARGB(255, 23, 23, 23) : widget.appBar_Color!.withAlpha(30))),
            backGroundColor_ChildDetails: (item.isShowDetails ? Colors.grey[900] : widget.item_BackGroundColor ?? (widget.appBar_Color == null ? widget.item_BackGroundColor ?? Color.fromARGB(255, 23, 23, 23) : widget.appBar_Color!.withAlpha(30))),
            onDoubleTapItem: widget.onDoubleTapItem,
            showTrailingArrow: false,
            widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
            onTapItem: widget.onTapItem != null ? () => widget.onTapItem!(item) : null,
            xLayout_Item_RowWidgets: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),
            edited: widget.edited!,
            //Widget che raffigura i dettagli che sono dentro la riga espansa
            childDetails: Column(mainAxisSize: MainAxisSize.min, children: [(widget.liDettsSubArea_Widgets != null ? widget.liDettsSubArea_Widgets!(item) ?? Container() : Container())]))
        : (widget.elDettsMode_SchItem != null && widget.elDettsMode_SchItem!)
            ? xLayout_DettItemWidget(item) ??
                XElencoItem(item, widget.view!,
                    funct: widget.functInItem,
                    showingDetails: item.isShowDetails,
                    margin: EdgeInsets.symmetric(vertical: 2),
                    backGroundColor_ChildMain: (item.isShowDetails ? Colors.grey[900] : widget.item_BackGroundColor ?? (widget.appBar_Color == null ? widget.item_BackGroundColor ?? Color.fromARGB(255, 23, 23, 23) : widget.appBar_Color!.withAlpha(30))),
                    backGroundColor_ChildDetails: (item.isShowDetails ? Colors.grey[900] : widget.item_BackGroundColor ?? (widget.appBar_Color == null ? widget.item_BackGroundColor ?? Color.fromARGB(255, 23, 23, 23) : widget.appBar_Color!.withAlpha(30))),
                    onDoubleTapItem: widget.onDoubleTapItem,
                    widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
                    showTrailingArrow: true,
                    xLayout_Item_RowWidgets: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),
                    onTapItem: widget.onTapItem != null ? () => widget.onTapItem!(item) : null,
                    edited: widget.edited!,
                    // onTapItem: () async {
                    //   xOnTapItem(item);
                    //   if (widget.onTapItem != null) {
                    //     widget.onTapItem!();
                    //   }
                    //   (widget.schNameToOpen != null
                    //       ? Navigator.pushNamed(context, widget.schNameToOpen!, arguments: item).then((value) {
                    //           setState(() {
                    //             isBusy = false;
                    //           });
                    //           rebuildAllChildren(context);
                    //         }) //
                    //       : setState(() => item.isShowDetails = item.isShowDetails.not()));
                    // },

                    //Widget che raffigura la riga che si espande
                    // childMain: Container(
                    //     // decoration: item.isShowDetails ? BoxDecoration(border: Border(bottom: BorderSide(width: 1, color: Colors.white))) : null,
                    //     padding: EdgeInsets.symmetric(horizontal: 2, vertical: 8),
                    //     child: Row(children: [
                    //       Expanded(
                    //           child: Column(
                    //               crossAxisAlignment: CrossAxisAlignment.start,
                    //               children: widget.view!.cols.groupListsBy((element) => element.originY).entries.map((e) {
                    //                 return Wrap(
                    //                     spacing: 3,
                    //                     runSpacing: 5,
                    //                     children: e.value.map((e) {
                    //                       return xLayout_Item_RowWidgets(e, item);
                    //                     }).toList());
                    //               }).toList())),
                    //       li.isNotEmpty ? Text((widget.viewDetts!.title ?? "") + ": " + (li.isNotEmpty ? (li.length.toString()) : "0"), style: XStyles.xStyTextForDescr(Colors.white), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis) : Container(),
                    //       xLayout_BTN_Function(item),
                    //       (t != null && t.isNotEmpty) ? xLayout_BTN_ExpandedItem(item) : Container()
                    //     ])),
                    //Widget che raffigura i dettagli che sono dentro la riga espansa
                    childDetails: Container(width: MediaQuery.of(context).size.width, child: XScheda(widget.key, item, widget.viewDetts!, modePage_Active: false)))
            : xLayout_DettItemWidget(item) ??
                XElencoItem(item, widget.view!,
                    funct: widget.functInItem,
                    showingDetails: item.isShowDetails,
                    margin: EdgeInsets.symmetric(vertical: 2),
                    backGroundColor_ChildMain: (item.isShowDetails ? Colors.grey[900] : widget.item_BackGroundColor ?? (widget.appBar_Color == null ? widget.item_BackGroundColor ?? Color.fromARGB(255, 23, 23, 23) : widget.appBar_Color!.withAlpha(30))),
                    backGroundColor_ChildDetails: (item.isShowDetails ? Colors.grey[900] : widget.item_BackGroundColor ?? (widget.appBar_Color == null ? widget.item_BackGroundColor ?? Color.fromARGB(255, 23, 23, 23) : widget.appBar_Color!.withAlpha(30))),
                    onDoubleTapItem: widget.onDoubleTapItem,
                    edited: widget.edited!,
                    showTrailingArrow: false,
                    widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
                    onTapItem: () async {
                      await xOnTapItem(item);
                      if (widget.onTapItem != null) {
                        widget.onTapItem!(item);
                      }

                      (widget.schNameToOpen != null && widget.schedaMode == false
                          ? Navigator.pushNamed(context, widget.schNameToOpen!, arguments: item).then((value) {
                              setState(() {
                                isBusy = false;
                                widget.xOnReturnBack != null ? widget.xOnReturnBack!(setState) : null;
                                widget.edited!.value;
                              });

                              rebuildAllChildren(context);
                            }) //
                          : setState(() => item.isShowDetails = item.isShowDetails.not()));
                    },
                    xLayout_Item_RowWidgets: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),

                    //Widget che raffigura la riga che si espande
                    // childMain: Container(
                    //     decoration: item.isShowDetails ? BoxDecoration(border: Border(bottom: BorderSide(width: 1, color: Colors.white))) : null,
                    //     padding: EdgeInsets.symmetric(horizontal: 2, vertical: 8),
                    //     child: Row(children: [
                    //       Expanded(
                    //           child: Column(
                    //               crossAxisAlignment: CrossAxisAlignment.start,
                    //               children: widget.view!.cols.groupListsBy((element) => element.originY).entries.map((e) {
                    //                 return Wrap(
                    //                     spacing: 3,
                    //                     runSpacing: 5,
                    //                     children: e.value.map((e) {
                    //                       return xLayout_Item_RowWidgets(e, item);
                    //                     }).toList());
                    //               }).toList())),
                    //       li.isNotEmpty ? Text((widget.viewDetts!.title ?? "") + ": " + (li.isNotEmpty ? (li.length.toString()) : "0"), style: XStyles.xStyTextForDescr(Colors.white), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis) : Container(),
                    //       xLayout_BTN_Function(item),
                    //       (t != null && t.isNotEmpty) ? xLayout_BTN_ExpandedItem(item) : Container()
                    //     ])),
                    //Widget che raffigura i dettagli che sono dentro la riga espansa
                    childDetails: Column(mainAxisSize: MainAxisSize.min, children: [(widget.liDettsSubArea_Widgets != null ? widget.liDettsSubArea_Widgets!(item) ?? Container() : Container())]));
  }

  Widget xLayout_Item_RowWidgets(XCol xCol, XFDataItem item) {
    return Container();
  }

  Widget xLayout_AreaElenco() {
    return StatefulBuilder(builder: (context, setState) {
      return Container(
          margin: EdgeInsets.symmetric(horizontal: widget.margin_Horizontal ?? 2),
          child: Column(children: [
            widget.searchBar_Active && list.length > 5
                ? Row(children: [
                    Expanded(
                        child: XSearchBar(
                            marginOfSearchBox: EdgeInsets.symmetric(vertical: 2),
                            paddingOfContent: EdgeInsets.only(left: 5),
                            hintStyle: XStyles.xStyTextForSubLabel(widget.searchBar_ColorHint ?? Colors.white),
                            textStyle: XStyles.xStyTextForSubLabel(widget.searchBar_ColorText ?? Colors.white),
                            colorIconForClear: widget.searchBar_ColorIconClear ?? Colors.white,
                            colorIconForSearch: widget.searchBar_ColorIconSearch ?? Colors.white,
                            autoFocus: false,
                            onTextChanged: (value) {
                              setState(() {
                                if (value == "") {
                                  searchController.text = "";
                                  filterCurrent = filterAll;
                                } else {
                                  filterCurrent = value;
                                }
                              });
                            },
                            onPressedClear: () {
                              setState(() {
                                filterCurrent = filterAll;
                                searchController.text = "";
                              });
                            },
                            border: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                            disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                            enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                            controller: searchController,
                            colorOfSearchBox: widget.searchBar_Color,
                            hintText: widget.searchBar_hintText ?? "cerca..",
                            iconForSearch: null))
                  ])
                : Container(),
            widget.title_OnTop_Visible == true
                ? Row(
                    children: [
                      Expanded(
                          child: XContainerWithLabel(
                        widget.title_Text,
                        height: widget.heightContainerElTitle,
                        color: widget.colorBackgroundContainerElTitle ?? widget.searchBar_Color ?? XColors.backGroundTitleContainerForElenco,
                        textStyle: widget.title_Style ?? XStyles.xStyTextForTextBase(XColors.foregroundDark),
                      )),
                      widget.BTNtitle_Visible == true
                          ? Container(
                              margin: widget.BTNtitle_Margin ?? EdgeInsets.only(left: 5),
                              height: widget.BTNtitle_Height ?? 25,
                              width: widget.BTNtitle_Width ?? 70,
                              child: XBtnbase(
                                label: widget.BTNtitle_Label ?? "Add New",
                                onPressed: widget.BTNtitle_OnPressed,
                                decoration: BoxDecoration(color: widget.BTNtitle_Color),
                              ),
                            )
                          : Container(),
                    ],
                  )
                : Container(),
            SizedBox(height: widget.headers_Visible == true && widget.headers_Visible != null ? 3 : 0),
            widget.headers_Visible == true && widget.headers_Visible != null ? Row(children: widget.headers!) : Container(),
            SizedBox(height: widget.headers_Visible == true && widget.headers_Visible != null ? 5 : 0),
            widget.filters_Visible == true && widget.filters_Visible != null ? Row(children: widget.filters!) : Container(),
            SizedBox(height: widget.filters_Visible == true && widget.filters_Visible != null ? 5 : 0),
            Expanded(
                flex: widget.flexForList ?? 18,
                child: (widget.schedaMode ?? false).not()
                    ? RefreshIndicator(
                        triggerMode: RefreshIndicatorTriggerMode.anywhere,
                        onRefresh: widget.onRefresh_ScrollDownList != null ? () => widget.onRefresh_ScrollDownList!(context) : () async {},
                        child: Scrollbar(
                            thumbVisibility: true,
                            controller: scroll_controller,
                            child: ListView(
                              children: widget.liDetts != null
                                  ? widget.liDetts!.where((element) => widget.searchBar_whereMethod != null ? widget.searchBar_whereMethod!(element, filterCurrent) : element != null).map((e) {
                                      return widget.item_Widget != null
                                          ? widget.item_Widget!(e) ?? Container() //
                                          : xLayout_ItemWidget(e) ?? Container();
                                    }).toList()
                                  : list.where((element) => widget.searchBar_whereMethod != null ? widget.searchBar_whereMethod!(element, filterCurrent) : element != null).map((e) {
                                      return widget.item_Widget != null
                                          ? widget.item_Widget!(e) ?? Container() //
                                          : xLayout_ItemWidget(e) ?? Container();
                                    }).toList(),
                              controller: scroll_controller,
                            )))
                    : Scrollbar(
                        thumbVisibility: true,
                        controller: scroll_controller,
                        child: ListView(
                          children: widget.liDetts != null
                              ? widget.liDetts!.where((element) => widget.searchBar_whereMethod != null ? widget.searchBar_whereMethod!(element, filterCurrent) : element != null).map((e) {
                                  return widget.item_Widget != null
                                      ? widget.item_Widget!(e) ?? Container() //
                                      : xLayout_ItemWidget(e) ?? Container();
                                }).toList()
                              : list.where((element) => widget.searchBar_whereMethod != null ? widget.searchBar_whereMethod!(element, filterCurrent) : element != null).map((e) {
                                  return widget.item_Widget != null
                                      ? widget.item_Widget!(e) ?? Container() //
                                      : xLayout_ItemWidget(e) ?? Container();
                                }).toList(),
                          controller: scroll_controller,
                        )))
          ]));
    });
  }

  List<Widget> xLayout_Actions() {
    return [];
  }

  @override
  Widget build(BuildContext context) {
    return widget.pageMode_Active
        ? Scaffold(
            appBar: AppBar(
                toolbarHeight: 50,
                // leading: widget.xDrawerMenu != null ? null : XBtnbase(icon: Icons.menu, onPressed: widget.onPressed_MENU, width: 40, icon_Size: 28, height: 40),
                title: Text(
                  widget.title_Text,
                  style: widget.title_Style ?? XStyles.xStyTextForLabel(XColors.foregroundLight),
                ),
                backgroundColor: widget.appBar_Color,
                actions: [
                  Container(margin: EdgeInsets.symmetric(vertical: 5, horizontal: 5), child: Row(children: xLayout_Actions())),
                  XBtnbase(
                    icon: Icons.replay_outlined,
                    onPressed: widget.onRefresh_ScrollDownList != null ? () => widget.onRefresh_ScrollDownList!(context) : () {},
                    width: 40,
                    height: 40,
                    margin: EdgeInsets.all(5),
                  ),
                ]),
            body: Stack(children: [
              isBusy ? Container(color: Colors.black.withAlpha(180)) : xLayout_AreaElenco(),
              isBusy ? XStatefulWidgetBase.LoaderIndicator(isBusy, label: waiterMessage) : Container(),
            ]),
            floatingActionButton: widget.allowAdd ? _buildAddBTN() : widget.floatingActionButton,
            drawer: widget.xDrawerMenu)
        : xLayout_AreaElenco();
  }

  Widget _buildAddBTN() {
    return XBtnbase(
      margin: EdgeInsets.only(bottom: 20),
      width: 50,
      height: 50,
      radiusBorder: 20,
      toolTip_Message: "Aggiungi ${widget.title_Text}",
      icon: Icons.add,
      icon_Color: XColors.foregroundLight,
      backGroundColor: widget.appBar_Color ?? widget.title_Color ?? widget.searchBar_Color,
      onPressed: widget.cmd_Add != null ? () => widget.cmd_Add!(setState) : null,
    );
  }
}

class XPopUpMenuItem {
  String? title;
  String? toolTip_Message;
  Color? color;
  IconData? icon;
  Image? iconImage;
  Function(BuildContext, dynamic)? onPressed;
  XPopUpMenuItem({
    this.color,
    this.onPressed,
    this.title,
    this.icon,
    this.iconImage,
    this.toolTip_Message,
  });
}
