part of xwidgetbase;

InputBorder? borderStyle() {
  return UnderlineInputBorder(borderRadius: BorderRadius.all(Radius.circular(4.0)), borderSide: BorderSide(width: 1, color: Colors.white));
}

class XColFilter extends StatefulWidget {
  XColFilter({
    Key? key,
    this.heightFilter,
    this.colorBackgroundFilter,
    this.propName,
    this.hintTextOfFilter,
    this.onChangedFilter,
    this.onPressedFilterSearch,
    this.colorBorderOfFilter,
  }) : super(key: key);
  final Color? colorBackgroundFilter;
  final double? heightFilter;
  final String? propName;
  final String? hintTextOfFilter;
  final Function(String)? onChangedFilter;
  final Function()? onPressedFilterSearch;
  final Color? colorBorderOfFilter;
  @override
  _XColFilterState createState() => _XColFilterState();
}

class _XColFilterState extends State<XColFilter> {
  String? initialValue = "";

  @override
  void initState() {
    super.initState();
  }

  sortString(dynamic a, dynamic b, String propName) {
    var resData = a.getProp(propName).compareTo(b.getProp(propName));
    return resData;
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: () {
          setState(() {});
        },
        child: Container(
            decoration: BoxDecoration(border: Border.all(width: 1, color: widget.colorBorderOfFilter ?? XColors.foregroundLight), color: widget.colorBackgroundFilter),
            child: Row(
              crossAxisAlignment: CrossAxisAlignment.end,
              children: [
                Expanded(child: Container(color: widget.colorBackgroundFilter, height: widget.heightFilter ?? 35, child: XTextFormField(onChanged: widget.onChangedFilter, contentPadding: EdgeInsets.only(top: 10, left: 5, bottom: 1), height: 32, hintStyle: TextStyle(color: widget.colorBorderOfFilter ?? XColors.foregroundLight), initialValue: initialValue, border: borderStyle(), maxLines: 1, multiLines: false, disabledBorder: borderStyle(), enabledBorder: borderStyle(), hintText: widget.hintTextOfFilter ?? "", suffixIcon: IconButton(icon: Icon(Icons.search, size: 20, color: widget.colorBorderOfFilter ?? XColors.foregroundLight), onPressed: widget.onPressedFilterSearch)))),
              ],
            )));
  }
}
