part of xwidgetbase;

class XHeaderWithSorting extends StatefulWidget {
  XHeaderWithSorting({
    Key? key,
    this.title,
    this.label = "",
    this.decoration,
    this.typeUI,
    this.iconContainerWidth,
    this.iconContainerheight,
    this.elevation,
    this.icon,
    this.style,
    this.iconSize,
    this.colorBackgroundHeader = Colors.black,
    this.textColor,
    this.iconColor = Colors.black,
    this.onPressed,
    this.child,
    this.padding,
    this.shape,
    this.flex,
    this.onTap,
    this.listInUI,
    this.heightHeader,
    this.widthHeader,
    this.styleLabel,
    this.colorIcon,
    this.propName,
    this.onTapHeader,
    this.iconChanged,
    this.listForSort,
  }) : super(key: key);
  final String? title;
  final String? label;
  final IconData? icon;
  final Function()? onPressed;
  final Decoration? decoration;
  final TextStyle? style;
  final Color? textColor;
  final Color? iconColor;
  final Color colorBackgroundHeader;
  final Widget? child;
  final double? elevation;
  final EdgeInsetsGeometry? padding;
  final OutlinedBorder? shape;
  final double? iconSize;
  final double? iconContainerWidth;
  final double? iconContainerheight;
  final int? typeUI;
  final int? flex;
  final Function()? onTap;
  final List<dynamic>? listInUI;
  final double? heightHeader;
  final double? widthHeader;
  final TextStyle? styleLabel;
  final Color? colorIcon;
  final String? propName;
  final Function()? onTapHeader;
  late bool? iconChanged;
  final List<dynamic>? listForSort;

  @override
  _XHeaderWithSortingState createState() => _XHeaderWithSortingState();
}

class _XHeaderWithSortingState extends State<XHeaderWithSorting> {
  IconData? sortActive = Icons.expand_less;
  IconData? sortDeactive = Icons.expand_more;
  int? typeOfIcon = 0;
  @override
  void initState() {
    widget.iconChanged = false;
    super.initState();
  }

  sortString(dynamic a, dynamic b, String propName) {
    var resData = a.getProp(propName).compareTo(b.getProp(propName));
    return resData;
  }

  IconData? typeOfIconWidget() {
    if (typeOfIcon == 0) {
      return null;
    } else if (typeOfIcon == 1) {
      return sortActive;
    } else if (typeOfIcon == 2) {
      return sortDeactive;
    } else {
      return null;
    }
  }

  onTapForSort() {
    setState(() {
      widget.onTapHeader; // TODO da vedere perche non so come fare il sort a seconda di quale è attivo
      widget.iconChanged = !widget.iconChanged!;
      if (typeOfIcon == 0) {
        typeOfIcon = 1;
      } else if (typeOfIcon == 1) {
        typeOfIcon = 2;
      } else if (typeOfIcon == 2) {
        typeOfIcon = 0;
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: onTapForSort,
        child: Container(
            decoration: BoxDecoration(
              border: Border.all(width: 1, color: Colors.black),
              color: widget.colorBackgroundHeader,
            ),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                Container(
                    color: widget.colorBackgroundHeader,
                    height: widget.heightHeader,
                    alignment: Alignment.center,
                    child: Text(
                      widget.label ?? "",
                      style: widget.styleLabel ?? TextStyle(color: XColors.foregroundLight),
                    )),
                typeOfIcon != 0 ? Container(child: Icon(typeOfIconWidget(), color: widget.colorIcon)) : Container(),
              ],
            )));
  }
}
