part of xsch;

extension BuilderSchWidget on XSchedaState {
  calcCell_Negative(XCol xCol, TextEditingController controller, numForCalc) {
    var x;
    if (controller.text == "") {
    } else {
      if (xCol.dataType == double) {
        x = double.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      } else if (xCol.dataType == int) {
        x = int.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      }
    }

    return x;
  }

  calcCell_Positive(XCol xCol, TextEditingController controller, numForCalc) {
    var x;
    if (xCol.dataType == double) {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = double.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    } else if (xCol.dataType == int) {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = int.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    }
    return x;
  }

  builderEntryDialog_BTNs(TextEditingController controller, String valueAndLabel, bool isSconto, {XCol? xCol}) {
    return XBtnbase(
        width: 40,
        height: 40,
        label_Style: XStyles.xStyTextForSubLabel(valueAndLabel.contains("+")
            ? Colors.green
            : valueAndLabel.contains("-") || valueAndLabel == ("C")
                ? Colors.red
                : Colors.green),
        label: valueAndLabel,
        backGroundColor: Colors.grey[800],
        onPressed: () {
          if (valueAndLabel == "C") {
            controller.text = "";
          } else {
            if (isSconto) {
              controller.text += calcSconto(controller, valueAndLabel);
            } else {
              if (valueAndLabel.contains("-")) {
                calcCell_Negative(xCol!, controller, int.parse(valueAndLabel.replaceFirst("-", "")));
              } else {
                calcCell_Positive(xCol!, controller, int.parse(valueAndLabel.replaceFirst("+", "")));
              }
            }
            controller.selection = TextSelection(baseOffset: controller.text.length, extentOffset: controller.text.length);
          }
        });
  }

  calcSconto(TextEditingController controller, String value) {
    if (controller.text == "") {
      return value.replaceAll("+", "");
    } else {
      return value;
    }
  }

//Dialog per l'editing dei campi con i vari pulsanti di help
  Future<dynamic> xEntryDialog(String title, dynamic value, XCol xCol, {Widget? content}) async {
    FocusScope.of(context).unfocus();
    setState(() {
      enteredInEditOnCell = true;
    });
    TextEditingController textController = TextEditingController(text: value.toString());

    var res = await showDialog<dynamic>(
        context: context,
        barrierDismissible: false,
        builder: (context) {
          return StatefulBuilder(
            builder: (context, setState) {
              return Container(
                  alignment: Alignment.center,
                  child: SingleChildScrollView(
                      child: XAlertDialog(
                          content_insetPadding: EdgeInsets.all(5),
                          height: null,
                          title_Text: title,
                          title_Style: XStyles.xStyTextForLabel(Colors.blue),
                          btnYES_label: "OK",
                          btnNO_label: "Annulla",
                          btnNO_OnPressed: () {
                            Navigator.pop(context, null);
                          },
                          btnYES_OnPressed: () {
                            if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
                              value = textController.text;
                            } else if (xCol.dataType == DateTime) {
                              var t = textController.text.split("-");
                              value = DateTime.parse(t[2] + "-" + t[1] + "-" + t[0]);
                            } else if (xCol.dataType == double) {
                              value = double.parse(textController.text);
                            } else if (xCol.dataType == int) {
                              value = int.parse(textController.text);
                            }

                            // lo fa già xOnXCell_Edit_SubmitValue
                            xOnXCell_Edit_SubmitValue(xCol, value, setState);
                            Navigator.pop(context, value);
                          },
                          child: content != null
                              ? content
                              : Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
                                  (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != DateTime && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                      ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                          Expanded(
                                              child: Wrap(alignment: WrapAlignment.end, spacing: 8, runSpacing: 8, children: [
                                            builderEntryDialog_BTNs(textController, "+50", true),
                                            builderEntryDialog_BTNs(textController, "+30", true),
                                            builderEntryDialog_BTNs(textController, "+10", true),
                                          ]))
                                        ])
                                      : ((xCol.dataType == String).not() && xCol.dataType != DateTime)
                                          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                              Expanded(
                                                  child: Wrap(spacing: 8, runSpacing: 8, children: [
                                                builderEntryDialog_BTNs(textController, "-20", false, xCol: xCol),
                                                builderEntryDialog_BTNs(textController, "-10", false, xCol: xCol),
                                                builderEntryDialog_BTNs(textController, "-5", false, xCol: xCol),
                                                builderEntryDialog_BTNs(textController, "-3", false, xCol: xCol),
                                                xCol.dataType == String && xCol.colKey.startsWith("li").not() ? Container(height: 0, width: 0) : builderEntryDialog_BTNs(textController, "-1", false, xCol: xCol),
                                              ]))
                                            ])
                                          : Container(),
                                  SizedBox(height: 10),
                                  (xCol.dataType == String && xCol.colKey.startsWith("li").not() && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                      ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                          Expanded(child: xDialog_CellBuilder(xCol, context, setState, textController)),
                                          SizedBox(width: 10),
                                          builderEntryDialog_BTNs(textController, "C", false),
                                        ])
                                      : xCol.dataType == String && xCol.colKey.startsWith("li").not()
                                          ? Column(mainAxisAlignment: MainAxisAlignment.center, children: [
                                              Row(children: [Expanded(child: xDialog_CellBuilder(xCol, context, setState, textController))]),
                                              SizedBox(height: 10),
                                              Row(mainAxisAlignment: MainAxisAlignment.end, children: [
                                                XBtnbase(
                                                  width: 60,
                                                  height: 40,
                                                  label: "Copia \nTutto",
                                                  label_TextAlign: TextAlign.center,
                                                  label_Color: Colors.white,
                                                  padding: EdgeInsets.all(0),
                                                  backGroundColor: Colors.grey[800],
                                                  onPressed: () {
                                                    Clipboard.setData(ClipboardData(text: textController.text));
                                                    ScaffoldMessenger.of(context).showSnackBar(
                                                      SnackBar(content: Text('Testo copiato negli appunti')),
                                                    );
                                                  },
                                                ),
                                                SizedBox(width: 20),
                                                builderEntryDialog_BTNs(textController, "C", false),
                                              ])
                                            ])
                                          : xCol.dataType != DateTime
                                              ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                  Expanded(child: xDialog_CellBuilder(xCol, context, setState, textController)),
                                                ])
                                              : Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                  Expanded(child: xDialog_CellBuilder(xCol, context, setState, textController)),
                                                  SizedBox(width: 10),
                                                  builderEntryDialog_BTNs(textController, "C", false),
                                                ]),
                                  SizedBox(height: 10),
                                  (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != DateTime && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                      ? Row(
                                          mainAxisAlignment: MainAxisAlignment.center,
                                          children: [
                                            Expanded(
                                                child: Wrap(alignment: WrapAlignment.end, spacing: 8, runSpacing: 8, children: [
                                              builderEntryDialog_BTNs(textController, "+40", true),
                                              builderEntryDialog_BTNs(textController, "+20", true),
                                              builderEntryDialog_BTNs(textController, "+5", true),
                                            ]))
                                          ],
                                        )
                                      : ((xCol.dataType == String).not() && xCol.dataType != DateTime)
                                          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                              Expanded(
                                                  child: Wrap(spacing: 8, runSpacing: 8, children: [
                                                builderEntryDialog_BTNs(textController, "+20", false, xCol: xCol),
                                                builderEntryDialog_BTNs(textController, "+10", false, xCol: xCol),
                                                builderEntryDialog_BTNs(textController, "+5", false, xCol: xCol),
                                                builderEntryDialog_BTNs(textController, "+3", false, xCol: xCol),
                                                xCol.dataType == String && xCol.colKey.startsWith("li").not() ? Container() : builderEntryDialog_BTNs(textController, "+1", false, xCol: xCol),
                                              ]))
                                            ])
                                          : Container(),
                                ]))));
            },
          );
        });
    setState(() {
      enteredInEditOnCell = false;
    });
    return res;
  }

  Future<Widget?> xLayout_Override_EntryDialog(String title, dynamic value, XCol<dynamic> xCol) async {
    return null;
  }

  changeTabs(String colKeyOfList, String tabCaption) {
    setState(() {
      int idx;
      if (xTabs.value.any((element) => element.caption == tabCaption).not()) {
        idx = ((xTabs.value.length - 1) + 1);
        currentTabIndex = idx;
        xTabs.value.add(XTabItem(
          idx,
          tabCaption,
          tabCaption,
          content: tabViewPages(widget.xView.cols.firstWhere((element) => element.colKey == colKeyOfList)),
          labelColor_Active: widget.title_BackColor,
          labelColor_Disabled: widget.title_BackColor,
          iconColor_Active: widget.title_BackColor,
          iconColor_Disabled: widget.title_BackColor,
          color_backGroundTab: Colors.black,
          color_backGroundTab_Activate: Color.fromARGB(255, 75, 75, 75),
        ));
        if (xTabs.value.isEmpty) {
          tabController.dispose();
        }
        tabController = TabController(length: xTabs.value.length, vsync: this);
        tabController.index = idx;
      } else {
        tabController.dispose();
        tabController = TabController(length: xTabs.value.length, vsync: this);
        tabController.index = xTabs.value.firstWhere((element) => element.caption == tabCaption).idx;
      }
      editedPage.value = true;
      enteredInEditOnCell = false;
    });
  }

  Future<XFDataItem?> xLayout_DialogAddItem(XView xView, XFDataItem item) async {
    bool isFirst = false;
    int u = 0;
    for (var i in xView.cols) {
      if (i.readOnly == true) {
        continue;
      }
      u++;
      var x = await xEntryDialog(i.colCaption, item[i.colKey], i, content: await xLayout_Override_EntryDialog(i.colCaption, item[i.colKey], i));
      if (x == null) {
        if (u == 1) {
          isFirst = true;
        }
        break;
      } else {
        item[i.colKey] = x;
      }
    }
    if (isFirst) {
      return null;
    } else {
      return item;
    }
  }

  Container xDialog_CellBuilder(XCol xCol, BuildContext context, void Function(void Function()) setState, TextEditingController controller) {
    Widget _widgetForCell = Container();
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        xCol: xCol,
        autoFocus: true,
        controller: controller,
        label_Visible: false,
        multiLines: xCol.multilines,
        maxLines: xCol.multilines ? 4 : 1,
        editable: xCol.readOnly,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        onBefore_Edit: () {
          // xOnBefore_Edit(xCol, item);
        },
        // value: item ?? "",
        onChanged: (value) {
          xOnXCell_Edit_OnChanged(xCol, value);
        },
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      // var dt = DateTime.parse(controller.text.replaceRange(10, controller.text.length, ""));
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          onBefore_Edit: () {},
          controller: controller,
          // value: dt == DateTime(1900, 01, 01) ? null : dt,
          onDateSelected: (value) {
            // setState(() {
            //   btnUpdateChangesShow = true;
            xOnXCell_Edit_SubmitValue(xCol, value, setState);
            //});
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          label_Visible: false,
          maxLines: 1,
          borderColor: widget.cell_borderColor,
          borderColor_Disabled: widget.cell_borderColor_Disabled,
          labelColor_Disabled: widget.cell_labelColor_Disabled,
          autoFocus: true,
          onBefore_Edit: () {
            // xOnBefore_Edit(xCol, item);
          },
          keyboardType: TextInputType.number,
          controller: controller,
          // value: controller.text == "0.0" ? "" : double.parse(controller.text).toString(),
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) {
            xOnXCell_Edit_SubmitValue(xCol, double.parse(value), setState);
          },
          onChanged: (value) {
            if (value != "") {
              xOnXCell_Edit_OnChanged(xCol, double.parse(value));
            } else {
              xOnXCell_Edit_OnChanged(xCol, 0.0);
            }
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        label_Visible: false,
        autoFocus: true,
        xCol: xCol,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {
          // xOnBefore_Edit(xCol, item);
        },
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue(xCol, value, setState);
        },
        controller: controller,
        // value: controller.text == "0.0" ? "" : controller.text,
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "") {
            xOnXCell_Edit_OnChanged(xCol, int.parse(value));
          } else {
            xOnXCell_Edit_OnChanged(xCol, 0);
          }
        },
      );
    } else {
      return Container(width: 0, height: 0);
    }

    return Container(
      child: StatefulBuilder(builder: (context, setState) {
        return _widgetForCell;
      }),
    );
    //}
  }

  Widget xSch_TextFormField_Builder<T>({
    required BuildContext context,
    required XCol xCol,
    Function(String)? onChanged,
    Function(String)? onSubmitted,
    String? hintText,
    List<TextInputFormatter>? inputFormatters,
    TextInputType? keyboardType,
    bool editable = true,
    bool label_Visible = true,
    bool autoFocus = false,
    String? value,
    bool? selectText,
    bool? multiLines,
    double? height,
    int? maxLines,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Color? backgorundColor,
    Color? backgorundColor_Disabled,
    TextEditingController? controller,
    Function()? onBefore_Edit,
  }) {
    return XTextFormField(
      controller: value != null ? null : controller,
      border: OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
      disabledBorder: OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
      enabledBorder: OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
      label: label_Visible ? (xCol.colCaption + (xCol.format == "C" ? " €" : "")) : "",
      onChanged: onChanged,
      onFieldSubmitted: (value) {
        onSubmitted == null ? null : onSubmitted(value!);
      },
      autoFocus: autoFocus,
      onTap: () {
        if (controller != null) {
          if (xCol.dataType == String) {
          } else {
            controller.selection = TextSelection(baseOffset: 0, extentOffset: controller.text.length);
          }
        }
        onBefore_Edit!();
      },
      initialValue: controller != null ? null : value,
      // borderVisible: editable.not(),
      maxLines: maxLines,
      isCollapsed: false,
      enabled: editable.not(),
      height: null,
      fillColor: editable ? Colors.transparent : XSchedaState.color_CellBackGorundDisabled,
      filled: XSchedaState.color_CellBackGorundDisabled != null ? true : false,
      multiLines: (xCol.colCaption.toLowerCase().contains("email") || (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")) || xCol.colCaption.toLowerCase().contains("inidrizzo") || xCol.colCaption.toLowerCase().contains("ind"))
          ? false
          : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
              ? false
              : multiLines ?? false,
      contentPadding: EdgeInsets.only(top: 7, left: 5, bottom: 7),
      textStyle: XStyles.xStyleText(colorText: XSchedaState.color_Text),
      textAlign: keyboardType == TextInputType.number ? TextAlign.end : TextAlign.left,
      labelStyle: XStyles.xStyTextForLabel(editable.not() ? (XSchedaState.color_LabelText) : (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!)), //XSchedaState.colorOfHintText
      keyboardType: keyboardType ??
          ((xCol.colCaption.toLowerCase().contains("email"))
              ? TextInputType.emailAddress
              : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
                  ? TextInputType.phone
                  : (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto"))
                      ? TextInputType.number
                      : TextInputType.text),
      textCapitalization: (xCol.dataType == String && xCol.colKey.startsWith("li").not())
          ? TextCapitalization.sentences //
          : TextCapitalization.none,
      hintText: editable ? "..." : (hintText ?? "inserisci.."),
      inputFormatters: inputFormatters ?? [],
    );
  }

  Widget xSch_Text_Builder<T>({required BuildContext context, required XCol xCol, required String value, List<TextInputFormatter>? inputFormatters, double? height}) {
    return XTextWithLabel(
      label: xCol.colCaption,
      text: xCol.format == "C" ? XUtils.xToCurrency(context, double.parse(value)) : value,
      text_Style: XStyles.xStyTextForDescr(Colors.white),
      label_Style: XStyles.xStyTextForLabel(XSchedaState.color_HintText),
    );
  }

  Widget xSch_DateFormField_Builder({
    required XCol xCol,
    required Function(DateTime)? onDateSelected,
    bool editable = true,
    DateTime? value,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Function()? onBefore_Edit,
    TextEditingController? controller,
  }) {
    return GestureDetector(
        // onTap: () {
        //   onBefore_Edit!();
        // },
        child: DateTimeFormField(
            decoration: InputDecoration(
              contentPadding: EdgeInsets.only(right: 2, top: 2, bottom: 2),
              hintStyle: XStyles.xStyleText(fontSize: 15, colorText: XSchedaState.color_HintText),
              errorStyle: TextStyle(color: Colors.redAccent),
              border: OutlineInputBorder(borderSide: BorderSide(color: xCol.readOnly.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
              disabledBorder: OutlineInputBorder(borderSide: BorderSide(color: xCol.readOnly.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
              enabledBorder: OutlineInputBorder(borderSide: BorderSide(color: xCol.readOnly.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
              labelText: xCol.colCaption,
              constraints: BoxConstraints(maxHeight: 35),
              labelStyle: value != null ? XStyles.xStyTextForLabel(xCol.readOnly ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!) : (labelColor_Disabled ?? borderColor ?? Colors.grey[600]!)) : XStyles.xStyTextForDescr(editable.not() ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!) : (labelColor_Disabled ?? borderColor ?? Colors.grey[600]!)),
            ),
            enabled: xCol.readOnly.not(),
            initialValue: value,
            dateFormat: DateFormat("dd/MM/yy"),
            dateTextStyle: XStyles.xStyleText(fontSize: 15, colorText: Colors.white),
            initialEntryMode: DatePickerEntryMode.calendar,
            initialDatePickerMode: DatePickerMode.day,
            mode: DateTimeFieldPickerMode.date,
            autovalidateMode: AutovalidateMode.onUserInteraction,
            validator: (e) => (e?.day ?? 0) == 1 ? 'Perfavore sistema la data' : null,
            onDateSelected: (value) => onDateSelected!(value)));
  }
}
