library xsch;

import 'dart:convert';
import 'dart:ffi';

import 'package:flutter/material.dart';
import 'package:collection/collection.dart';
import 'package:date_field/date_field.dart';
import 'package:flutter/services.dart';
import 'package:intl/intl.dart';
import 'package:uuid/uuid.dart';
import 'package:xwidgetsbase/XfXWidgets/XElenco.dart';
import 'package:xwidgetsbase/XfXWidgets/XF_Col.dart';
import 'package:xwidgetsbase/XfXWidgets/XF_DataItem.dart';
import 'package:xwidgetsbase/XfXWidgets/XF_Utils.dart';
import 'package:xwidgetsbase/XfXWidgets/XF_View.dart';

import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:xwidgetsbase/XStylesBase.dart';
import 'package:xwidgetsbase/xWidgetsBase.dart';

import '../XWidgets/XResizer.dart';
part 'Xfx_SchComponents.dart';

class XScheda<T extends XFDataItem> extends StatefulWidget {
  //Ci facciamo passare l'oggetto da visualizzare T
  XScheda(
    Key? key,
    this.itemInEdit,
    this.xView, {
    this.title,
    this.title_BackColor,
    this.title_Color,
    this.title_Widgets,
    this.btnOK_label = "OK",
    this.btnCancel_label,
    this.modeDialog_Active = false,
    this.modePage_Active = true,
    this.editable = true,
    this.decoration,
    this.width,
    this.headerHeight = 0.4,
    this.cell_borderColor,
    this.cell_borderColor_Disabled,
    this.cell_labelColor_Disabled,
    this.viewSch_TYPE,
    this.xOnReturnBackFromScheda,
    this.liXView,
    this.detts_allowAdd = false,
    this.detts_OnEditValueInItem,
    this.detts_OnTapItem,
    this.detts_functItem,
  }) : super(key: key) {
    if (this.title_Widgets == null && modeDialog_Active == true) {
      //gestisco i titoli che verranno messi
      this.title_Widgets = [
        XContainerWithLabel(
          title,
          textStyle: XStyles.xStyTextForSubLabel(this.title_Color ?? XColors.foregroundLight),
          color: this.title_BackColor ?? XColors.backGroundTitleContainerForScheda_MAIN,
        ),
      ];
    }
  }
  T itemInEdit;
  final XView xView;
  late List<Widget>? title_Widgets;
  String? btnOK_label;
  String? btnCancel_label;
  String? title;
  Color? title_BackColor;
  Color? title_Color;
  bool modeDialog_Active;
  bool modePage_Active;
  bool editable;
  bool detts_allowAdd;
  double? width;
  Map<String, XView>? liXView;

  ///0.1 to 1.0 per indicare % di spazio VERT che deve avere l'HEADER
  double headerHeight;

  Decoration? decoration;
  Color? cell_borderColor;
  Color? cell_borderColor_Disabled;
  Color? cell_labelColor_Disabled;

  ///Se TRUE = fa vedere le TABS al posto dell'elenco a fazzolettone / Se FALSE fas vedere l'elenco a fazzolettone con dentro la scheda / se NULL fa vedere l'elenco semplice di RWO sotto l'header
  bool? viewSch_TYPE;
  Function(void Function(void Function()), bool)? xOnReturnBackFromScheda;
  Function(dynamic)? detts_OnEditValueInItem;
  Function(XFDataItem)? detts_OnTapItem;
  Function()? detts_functItem;
  @override
  State<XScheda<T>> createState() => XSchedaState<T>();
}

class XSchedaState<T extends XFDataItem> extends State<XScheda<T>> with TickerProviderStateMixin {
  //Propietà della Scheda
  bool enteredInEditOnCell = false;
  late T itemInEdit_Clone;
  bool btnUpdateChangesShow = false;
  List<XBottomNavigationBarItem> liBottomActions = List<XBottomNavigationBarItem>.empty(growable: true);
  ScrollController _scrollController = ScrollController();
  bool scroll_Active = false;
  final GlobalKey<FormState> _formkey = GlobalKey();

  ///Per gestire i Tab
  int currentTabIndex = 0;
  late TabController tabController;
  ValueNotifier<List<XTabItem>> xTabs = ValueNotifier<List<XTabItem>>([]);
  TickerProvider? vsync;

  static double heightOfEntryField = 46;
  static Color color_Text = XColors.foregroundLight;
  static Color color_LabelText = Colors.grey[300]!;
  static Color color_HintText = Color.fromARGB(255, 105, 105, 105);
  static Color color_TextDisabled = Colors.grey[700]!;
  static Color color_Border = Colors.grey[300]!;
  static Color color_BorderDisabled = Colors.grey[700]!;
  static Color? color_CellBackGorundDisabled;

  String waiterMessage = "";
  // NEW 20230114
  ValueNotifier<bool> editedPage = ValueNotifier(false);
  bool isBusy = false;
  @override
  void initState() {
    init_Sch();
    _xFillBottomBarActions(false);
    xfillxTabs();
    widget.cell_borderColor = XSchedaState.color_Border;
    widget.cell_borderColor_Disabled = XSchedaState.color_BorderDisabled;
    widget.cell_labelColor_Disabled = XSchedaState.color_TextDisabled;
    if (xTabs.value.isNotEmpty) {
      tabController = TabController(length: xTabs.value.length, vsync: this);
      tabController.addListener(() {
        setState(() {});
      });
    }
    super.initState();
  }

  @override
  void dispose() {
    _scrollController.dispose();
    super.dispose();
  }

  //Inizializzo la scheda riempendop l'Item Clone per avere possibilità di fare UNDO
  init_Sch() {
    itemInEdit_Clone = widget.itemInEdit.getCloneFull() as T;
  }

  xcmd_Save() async {
    //se è new gli do ID, prima di save che sovrascrive
    if (itemInEdit_Clone.id == "") {
      itemInEdit_Clone.id = Uuid().v4();
    }
    editedPage.value = false;
    itemInEdit_Clone.copyProps(itemInEdit_Clone, widget.itemInEdit);
    await xOnSaveAfter();
    // Navigator.pop(context);
  }

  ///TO BE OVERRIDE
  xOnSaveAfter() async {
    throw Exception("DEVI OVERRIDE questo metodo! xOnSaveAfter");
    // await appServices.set_Preventivo(widget.itemInEdit);
  }

//quando salvo ciclo per tutte le prop dell'attore e salvo le informazioni

  xOnXCell_Edit_OnChanged(XCol xCol, dynamic value) async {}

  ///called in a setState
  xOnXCell_Edit_AfterExit(XCol xCol, dynamic value, bool valueIsChanged, void Function(void Function()) parentSetState) {}
  xOnXCell_Edit_BeforeExit(XCol xCol, dynamic value, bool valueIsChanged) async {}
  xOnXCell_Edit_SubmitValue(XCol xCol, dynamic value, void Function(void Function()) parentSetState) {
    var valueIsChanged = itemInEdit_Clone[xCol.colKey] != value!;
    xOnXCell_Edit_BeforeExit(xCol, value, valueIsChanged);
    itemInEdit_Clone[xCol.colKey] = value!;
    xOnXCell_Edit_AfterExit(xCol, value, valueIsChanged, parentSetState);
    parentSetState(() {
      editedPage.value = editedPage.value | valueIsChanged;
      btnUpdateChangesShow = true;
    });
  }

  ///BUILDER DEI WIDGET NON EDITABILI///
  Container xLayout_CellWidget(XCol xCol, T item, BuildContext context) {
    late Widget _widgetForCell;
    if (xCol.dataType != DateTime) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        xCol: xCol,
        editable: false,
        hintText: "",
        value: itemInEdit_Clone[xCol.colKey].toString(),
        onChanged: (value) {},
      );
    } else {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        xCol: xCol,
        editable: false,
        hintText: "",
        value: XUtils.dateToString(itemInEdit_Clone[xCol.colKey] != null ? itemInEdit_Clone[xCol.colKey] : DateTime(1900, 01, 01), noDateLabel: ""),
        onChanged: (value) {},
      );
    }
    if (xCol.resizeStyle == 0) {
      // return Container(height: 40, constraints: BoxConstraints(minWidth: double.infinity, maxWidth: double.infinity), child: Container(margin: EdgeInsets.symmetric(horizontal: 2), child: _widgetForCell));
      return Container(constraints: BoxConstraints.tightForFinite(height: XSchedaState.heightOfEntryField), child: Container(margin: EdgeInsets.symmetric(horizontal: 2), child: _widgetForCell));
    }
    //Se la colonna è Width PROPORTIONAL
    else if (xCol.resizeStyle == 1) {
      return Container(height: XSchedaState.heightOfEntryField, width: xCol.width, constraints: BoxConstraints(minWidth: xCol.width * .9, maxWidth: xCol.width * 1.2), margin: EdgeInsets.symmetric(horizontal: 2), child: _widgetForCell);
    }
    //Se la colonna è Width FIX
    else {
      return Container(height: XSchedaState.heightOfEntryField, width: xCol.width, margin: EdgeInsets.symmetric(horizontal: 2), child: _widgetForCell);
    }
  }

  Widget xLayout_AdditionalActions(BuildContext context, T item, double height) {
    return Row(children: [Column(children: [])]);
  }

  Future<bool?> xLayout_Dialog(T item, {Widget? contentWidget, String? title, bool BTNno_Visible = true, String? BTN_Label_YES, String? BTN_Label_NO, Function()? onPressed}) async {
    return await showDialog<bool>(
        barrierDismissible: false,
        context: context,
        builder: (context) {
          return XAlertDialog(
              height: null,
              title_Text: title ?? "Modifica il campo qui sotto:",
              title_Style: XStyles.xStyTextForTextBase(XColors.foregroundLight),
              child: contentWidget ?? Container(height: 0, width: 0),
              actionsBTNarea_Child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                BTNno_Visible
                    ? Expanded(
                        child: XBtnbase(
                            label: BTN_Label_NO ?? "Annulla",
                            label_Style: XStyles.xStyTextForSubLabel(XColors.undo),
                            onPressed: () {
                              return Navigator.pop(context, false);
                            }))
                    : Container(),
                SizedBox(width: 10),
                Expanded(
                  child: XBtnbase(
                    label: BTN_Label_YES ?? "OK, avanti..",
                    label_Style: XStyles.xStyTextForSubLabel(XColors.done),
                    onPressed: onPressed,
                  ),
                )
              ]));
        });

    // return x;
  }

  List<XProp> titleDialog_liProps = List<XProp>.empty(growable: true);
  String titleDialog_EditCell = "";

  xOnBefore_Edit(XCol xCol, T item) async {
    if (titleDialog_liProps.isEmpty) {
      titleDialog_EditCell = xCol.colCaption;
    } else {
      for (var i in titleDialog_liProps) {
        titleDialog_EditCell = " " + i.col_Label;
      }
    }

    if ((isAndroid() || isIOS()) && widget.modePage_Active) {
      var x = await xEntryDialog(titleDialog_EditCell, item[xCol.colKey], xCol);
      if (x != null) {
        itemInEdit_Clone[xCol.colKey] = x;
      }
    }
    setState(() {
      btnUpdateChangesShow = false;
    });
    return () {};
  }

  Future<bool?> xWidget_OnBeforeInit_SchLayout(T item) async {
    return null;
  }

  ///BUILDER DEI WIDGET EDITABILI///
  Container xLayout_CellWidget_Editable(XCol xCol, T item, BuildContext context, void Function(void Function()) parentSetState) {
    Widget _widgetForCell = Container();
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        xCol: xCol,
        multiLines: xCol.multilines,
        maxLines: xCol.multilines ? 4 : 1,
        editable: xCol.readOnly,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue(xCol, double.parse(value), parentSetState);
        },
        onBefore_Edit: () {
          xOnBefore_Edit(xCol, item);
        },
        value: item[xCol.colKey] ?? "",
        onChanged: (value) {
          xOnXCell_Edit_OnChanged(xCol, value);
        },
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          borderColor: widget.cell_borderColor,
          borderColor_Disabled: widget.cell_borderColor_Disabled,
          labelColor_Disabled: widget.cell_labelColor_Disabled,
          onBefore_Edit: () => xOnBefore_Edit(xCol, item),
          value: item[xCol.colKey] == DateTime(1900, 01, 01) ? null : item[xCol.colKey],
          onDateSelected: (value) {
            // setState(() {
            //   btnUpdateChangesShow = true;
            xOnXCell_Edit_SubmitValue(xCol, value, parentSetState);
            //});
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          maxLines: 1,
          borderColor: widget.cell_borderColor,
          borderColor_Disabled: widget.cell_borderColor_Disabled,
          labelColor_Disabled: widget.cell_labelColor_Disabled,
          onBefore_Edit: () {
            xOnBefore_Edit(xCol, item);
          },
          keyboardType: TextInputType.number,
          value: item[xCol.colKey].toString() == "0.0" ? "" : double.parse(item[xCol.colKey].toString()).toString(),
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) {
            xOnXCell_Edit_SubmitValue(xCol, double.parse(value), parentSetState);
          },
          onChanged: (value) {
            if (value != "") {
              xOnXCell_Edit_OnChanged(xCol, double.parse(value));
            } else {
              xOnXCell_Edit_OnChanged(xCol, 0.0);
            }
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        xCol: xCol,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {
          xOnBefore_Edit(xCol, item);
        },
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue(xCol, value, parentSetState);
        },
        value: item[xCol.colKey].toString() == "0.0" ? "" : item[xCol.colKey].toString(),
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "") {
            xOnXCell_Edit_OnChanged(xCol, int.parse(value));
          } else {
            xOnXCell_Edit_OnChanged(xCol, 0);
          }
        },
      );
    } else {
      //DEVE essere W e H = 0 se no il Wrap fa casino nel gestirlo e va a "un po' a capo" dopo l'ultimo Widget
      return Container(width: 0, height: 0);
    }
    //DD 2023.01.28 qui i widget sono WRAPPED;, quind per ora il concetto del resizeStyle non ha un senso,m visto che lo U non può resizare
    //Se la colonna è Width FLEX
    // if (xCol.resizeStyle == 0) {
    //   // return Container(height: 40, constraints: BoxConstraints(minWidth: double.infinity, maxWidth: double.infinity), child: Container(margin: EdgeInsets.symmetric(horizontal: 2), child: _widgetForCell));
    //   return Container(margin: EdgeInsets.only(right: 5), constraints: BoxConstraints.tightForFinite(height: XSchedaState.heightOfEntryField), child: Container(margin: EdgeInsets.symmetric(horizontal: 2), child: _widgetForCell));
    // }
    // //Se la colonna è Width PROPORTIONAL
    // else if (xCol.resizeStyle == 1) {
    //   return Container(margin: EdgeInsets.only(right: 5), height: XSchedaState.heightOfEntryField, constraints: BoxConstraints(minWidth: xCol.width * .5, maxWidth: xCol.width * 1), child: _widgetForCell);
    // }
    //Se la colonna è Width FIX
    //else {

    return Container(
      width: xCol.width,
      child: StatefulBuilder(builder: (context, setState) {
        return _widgetForCell;
      }),
    );
    //}
  }

  String? validatorBL(dynamic value) {
    if (value == null) return "Fill in please";
    if (value is MapEntry<String, XEnumsDefs>) {
      return null;
    } else if (value is T) {
      {
        return null;
      }
    } else if (value is DateTime) {
      {
        return null;
      }
    } else if (value.isEmpty) {
      return "Fill in please";
    }
  }

  Widget get_TitlwWidget(int originY) {
    if (widget.modePage_Active) {
      return Container(width: 0, height: 0);
    } else {
      var titleIdxFromOriginY = 0;
      if (originY > 0) {
        titleIdxFromOriginY = originY ~/ 2;
        if (titleIdxFromOriginY > widget.title_Widgets!.length - 1) titleIdxFromOriginY = 0;
      }
      return widget.title_Widgets == null ? Container(width: 0, height: 0) : widget.title_Widgets![titleIdxFromOriginY];
    }
  }

  Widget xLayout_WidgetScheda(MapEntry<int, List<XCol<dynamic>>> e, List<Widget> children) {
    return Container(
        decoration: BoxDecoration(border: Border.all(width: 2, color: widget.title_Color ?? XColors.foregroundLight)),
        margin: EdgeInsets.only(bottom: 10),
        // padding: EdgeInsets.only(left: 5, right: 5),
        child: Column(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.start, children: [
          widget.modePage_Active ? Container(width: 0, height: 0) : get_TitlwWidget(e.key),
          widget.modePage_Active ? Container(width: 0, height: 0) : (widget.title_Widgets == null ? Container(width: 0, height: 0) : SizedBox(height: 15)),
          Container(
              padding: EdgeInsets.only(bottom: 5),
              alignment: Alignment.topLeft,
              margin: EdgeInsets.only(top: 10, left: 5, right: 5),
              child: Wrap(
                runSpacing: 15,
                spacing: 5,
                direction: Axis.horizontal,
                alignment: WrapAlignment.start,
                runAlignment: WrapAlignment.start,
                crossAxisAlignment: WrapCrossAlignment.start,
                children: children,
              ))
        ]));
  }

  xLayout_asContainer() {
    return SingleChildScrollView(
        child: Form(
            key: _formkey,
            child: Container(
                decoration: widget.decoration ?? BoxDecoration(border: Border.all(width: 3, color: color_HintText)),
                width: widget.width ?? (MediaQuery.of(context).size.width > 1600 ? MediaQuery.of(context).size.width / 1.2 : MediaQuery.of(context).size.width / 1.2),
                child: Column(
                    mainAxisSize: MainAxisSize.min,
                    children: widget.xView.cols.groupListsBy((element) => element.originY).entries.map(
                      (e) {
                        //x orgni sottoROW/grp
                        return Container(
                            child: xLayout_WidgetScheda(
                                e,
                                e.value.map(
                                  (e) {
                                    if (widget.editable) {
                                      return xLayout_CellWidget_Editable(e, itemInEdit_Clone, context, setState);
                                    } else {
                                      return xLayout_CellWidget(e, itemInEdit_Clone, context);
                                    }
                                  },
                                ).toList()));
                      },
                    ).toList()))));
  }

  List<XBottomNavigationBarItem> _xFillBottomBarActions(bool dataChanged) {
    liBottomActions = List<XBottomNavigationBarItem>.empty(growable: true);
    xFillBottomBarActions(dataChanged);
    return liBottomActions;
  }

  ///toBE OVERRIDE chiamata 2 volte, in init e in LAYOUT. la prima serve per far sapere al LAY che deve avere la BottomNavBar senza dover mettere un bool apposta
  List<XBottomNavigationBarItem> xFillBottomBarActions(bool dataChanged) {
    return liBottomActions;
  }

  onTapBottomBar(int currentIdx, void Function(void Function()) parentSetState) async {}

  List<Widget> xLayout_ActionsListWidgets() {
    return [];
  }

  xfillxTabs() {
    var t = 0;
    for (var i in widget.xView.cols) {
      var ifMore = widget.xView.cols.where((element) => element.colKey.startsWith("li"));
      if (i.colKey.startsWith("li") && itemInEdit_Clone.getProp(i.colKey).isNotEmpty) {
        xTabs.value.add(XTabItem(
          t,
          i.colCaption,
          i.colCaption,
          content: tabViewPages(widget.xView.cols.firstWhere((element) => element.colKey == i.colKey)),
          labelColor_Active: widget.title_BackColor,
          labelColor_Disabled: ifMore.length > 1 ? Colors.white : widget.title_BackColor,
          color_backGroundTab: Colors.black,
          color_backGroundTab_Activate: Color.fromARGB(255, 75, 75, 75),
          iconColor_Active: widget.title_BackColor,
          iconColor_Disabled: ifMore.length > 1 ? Colors.white : widget.title_BackColor,
        ));
        t++;
      }
    }
  }

  Widget? xLayout_ItemWidget(dynamic item) {
    return null;
  }

  List<Widget> xLayout_WidgetsLeftArea_DettsItem(dynamic item, void Function(void Function()) parentSetState) {
    return [];
  }

  tabViewPages(XCol xCol) {
    var typeProp = itemInEdit_Clone.getProp(xCol.colKey).runtimeType;
    var xViews_Flutter = widget.liXView!.entries.firstWhereOrNull((element) => element.key.contains((typeProp.toString().replaceAll("List<", "").replaceAll(">", "_Flutter"))) && element.key.contains("el_"));
    return StatefulBuilder(
      builder: (context, setState) {
        if (widget.viewSch_TYPE == true) {
          return XElenco(
            xCol.colCaption,
            typeProp != Type
                ? xViews_Flutter != null
                    ? xViews_Flutter.value
                    : null
                : null,
            pageMode_Active: false,
            functInItem: widget.detts_functItem,
            onTapItem: (item) {
              setState(() {
                waiterMessage = "Sto caricando...";
                // isBusy = true;
                editedPage.value = isBusy;
              });
              if (widget.detts_OnTapItem != null) {
                widget.detts_OnTapItem!(item as XFDataItem);
              }
              setState(() {
                waiterMessage = "";
                isBusy = false;
              });
            },
            edited: editedPage,
            liWidgets_LeftArea_Item: (item) => xLayout_WidgetsLeftArea_DettsItem(item, setState),
            cmd_Add: (setState) {
              xOnAddDett(itemInEdit_Clone);
            },
            xOnReturnBack: (setState) {
              super.setState(() {
                editedPage.value = true;
                enteredInEditOnCell = false;
                widget.xOnReturnBackFromScheda != null ? widget.xOnReturnBackFromScheda!(super.setState, enteredInEditOnCell) : null;
              });
            },
            schedaMode: true,
            appBar_Color: widget.title_BackColor,
            item_Widget: xLayout_ItemWidget(itemInEdit_Clone) != null ? ((item) => xLayout_ItemWidget(item)) : null,
            searchBar_Active: true,
            schNameToOpen: typeProp != Type ? "/Sch${typeProp.toString().replaceAll("List<", "").replaceAll(">", "")}" + ".dart" : null,
            liDetts: itemInEdit_Clone.getProp(xCol.colKey),
          );
        } else if (widget.viewSch_TYPE == false) {
          TabController controller;
          List<XTabItem> liTabs = List<XTabItem>.empty(growable: true);
          if (widget.viewSch_TYPE!) {
            var t = 0;
            for (var i in itemInEdit_Clone.getProp(xCol.colKey)) {
              liTabs.add(XTabItem(
                t,
                xCol.colCaption + " " + t.toString(),
                xCol.colCaption + " " + t.toString(),
                content: tabViewPages(widget.xView.cols.firstWhere((element) => element.colKey == xCol.colKey)),
                labelColor_Active: widget.title_BackColor,
                labelColor_Disabled: widget.title_BackColor,
                iconColor_Active: widget.title_BackColor,
                iconColor_Disabled: widget.title_BackColor,
              ));
              t++;
            }
          }
          controller = TabController(length: liTabs.length, vsync: this);
          return XfxSchedaTabbed(
            tabController: controller,
            margin_Horizontal: 0,
            tabs_BackGroundColor: Colors.grey[900],
            title_Visible: false,
            bottomBar_Visible: false,
            bottomBar_Children: [],
            numberOfTabs: controller.length,
            isScrollableTabs: false,
            children: liTabs.map((x) => x.content!).toList(),
            tabs: liTabs,
          );
        } else {
          return XElenco(
            xCol.colCaption,
            typeProp != Type
                ? xViews_Flutter != null
                    ? xViews_Flutter.value
                    : null
                : null,
            pageMode_Active: false,

            functInItem: widget.detts_functItem,
            onTapItem: (item) {
              super.setState(() {
                waiterMessage = "Sto caricando...";
                enteredInEditOnCell = true;
              });
              if (widget.detts_OnTapItem != null) {
                widget.detts_OnTapItem!(item as XFDataItem);
              }
              super.setState(() {
                waiterMessage = "";
                enteredInEditOnCell = false;
              });
            },
            cmd_Add: (setState) {
              xOnAddDett(itemInEdit_Clone);
            },
            liWidgets_LeftArea_Item: (item) => xLayout_WidgetsLeftArea_DettsItem(item, setState),
            xOnReturnBack: (setState) {
              super.setState(() {
                editedPage.value = true;
                enteredInEditOnCell = false;
                widget.xOnReturnBackFromScheda != null ? widget.xOnReturnBackFromScheda!(super.setState, enteredInEditOnCell) : null;
              });
            },
            schedaMode: true,
            edited: editedPage,
            appBar_Color: widget.title_BackColor,
            item_Widget: xLayout_ItemWidget(itemInEdit_Clone) != null ? ((item) => xLayout_ItemWidget(item)) : null,
            searchBar_Active: true,
            // schNameToOpen: typeProp != Type ? "/Sch${typeProp.toString().replaceAll("List<", "").replaceAll(">", "")}" + ".dart" : null,
            liDetts: itemInEdit_Clone.getProp(xCol.colKey),
          );
        }
      },
    );
  }

  Future<bool> xOnAddDett(T item) async {
    return false;
  }

  Widget? xLayout_BodyBuild() {
    return null;
  }

  Widget xLayout_HeadAreaBuilder() {
    return StatefulBuilder(builder: (context, setState) {
      return Container(
          child: Scrollbar(
              thumbVisibility: true,
              controller: _scrollController,
              child: SingleChildScrollView(
                  controller: _scrollController,
                  child: Form(
                      key: _formkey,
                      child: Container(
                          margin: EdgeInsets.only(bottom: 10),
                          decoration: widget.decoration ?? BoxDecoration(),
                          child: Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              mainAxisSize: MainAxisSize.min,
                              children: widget.xView.cols.groupListsBy((element) => element.originY).entries.map(
                                (e) {
                                  //x orgni sottoROW/grp
                                  return xLayout_WidgetScheda(
                                      e,
                                      e.value.map(
                                        (e) {
                                          if (widget.editable) {
                                            return xLayout_CellWidget_Editable(e, itemInEdit_Clone, context, setState);
                                          } else {
                                            return xLayout_CellWidget(e, itemInEdit_Clone, context);
                                          }
                                        },
                                      ).toList());
                                },
                              ).toList()))))));
    });
  }

  xLayout_asPage(BuildContext context) {
    return StatefulBuilder(builder: (context, setState) {
      return WillPopScope(
          onWillPop: () => cmd_Back(),
          child: GestureDetector(
              onTap: () => FocusScope.of(context).unfocus(),
              child: Scaffold(
                appBar: AppBar(
                  iconTheme: IconThemeData(color: widget.title_BackColor ?? XColors.foregroundDark),
                  title: Text(widget.title ?? "", style: XStyles.xStyTextForLabel(widget.title_BackColor ?? XColors.foregroundDark)),
                  backgroundColor: widget.title_Color,
                  actions: [
                    Row(children: [
                      widget.detts_allowAdd
                          ? Container(
                              margin: EdgeInsets.only(bottom: 5, top: 5, right: 5),
                              child: Row(children: [
                                XBtnbase(
                                  icon: Icons.add,
                                  onPressed: () async {
                                    setState(() {
                                      waiterMessage = "Sto caricando...";
                                      isBusy = true;
                                    });
                                    await xOnAddDett(itemInEdit_Clone).then((value) {
                                      super.setState(() {
                                        waiterMessage = "";
                                        isBusy = false;
                                      });
                                    });
                                  },
                                  icon_Size: 25,
                                  elevation: 0,
                                  icon_WidthArea: 30,
                                  backGroundColor: widget.title_BackColor,
                                  icon_Color: widget.title_BackColor ?? XColors.foregroundDark,
                                  height: 40,
                                  width: 40,
                                )
                              ]))
                          : Container(),
                      Container(margin: EdgeInsets.only(bottom: 8, right: 5), child: Row(children: xLayout_ActionsListWidgets())),
                    ])
                  ],
                ),
                body: Stack(children: [
                  enteredInEditOnCell
                      ? Container()
                      : xLayout_BodyBuild() != null
                          ? xLayout_BodyBuild() ?? Container()
                          : xTabs.value.isNotEmpty
                              ? XResizableWidget(
                                  isHorizontalSeparator: true,
                                  separatorColor: Color.fromARGB(255, 75, 75, 75),
                                  separatorSize: 30,
                                  percentages: [widget.headerHeight, 1.0 - widget.headerHeight],
                                  title: xTabs.value.length == 1 ? xTabs.value.first.label : "",
                                  children: [
                                    xLayout_HeadAreaBuilder(),
                                    xTabs.value.isEmpty
                                        ? Container(height: 0)
                                        : xTabs.value.length <= 1
                                            ? xTabs.value.map((x) => x.content!).first
                                            : XfxSchedaTabbed(
                                                tabController: tabController,
                                                margin_Horizontal: 0,
                                                // tabs_BackGroundColor: Colors.transparent,
                                                title_Visible: false,
                                                bottomBar_Visible: false,
                                                bottomBar_Children: [],
                                                numberOfTabs: xTabs.value.length,
                                                isScrollableTabs: xTabs.value.length > 3 ? true : false,
                                                children: xTabs.value.map((x) => x.content!).toList(),
                                                tabs: xTabs.value,
                                              )
                                  ])
                              : xLayout_HeadAreaBuilder(),
                  isBusy ? Container(color: Colors.black.withAlpha(180)) : Container(),
                  isBusy ? XStatefulWidgetBase.LoaderIndicator(isBusy, label: waiterMessage) : Container(),
                ]),
                bottomNavigationBar: (liBottomActions.isNotEmpty)
                    ? BottomNavigationBar(
                        items: _xFillBottomBarActions(editedPage.value),
                        type: BottomNavigationBarType.fixed,
                        currentIndex: 0,
                        onTap: (value) async => await onTapBottomBar(value, setState),
                        enableFeedback: true,
                        showUnselectedLabels: true,
                        selectedFontSize: 15,
                        selectedLabelStyle: XStyles.xStyleText(fontSize: 14, colorText: XColors.foregroundLight),
                        backgroundColor: Colors.grey[900],
                        unselectedItemColor: XColors.foregroundLight,
                        unselectedFontSize: 10,
                        useLegacyColorScheme: false,
                        unselectedLabelStyle: XStyles.xStyleText(fontSize: 14, colorText: XColors.foregroundLight),
                        iconSize: 20,
                      )
                    : null,
              )));
    });
  }

  void rebuildAllChildren(BuildContext context) {
    void rebuild(Element el) {
      el.markNeedsBuild();
      el.visitChildren(rebuild);
    }

    (context as Element).visitChildren(rebuild);
  }

  xBuilder_asDialog(double maxRowLen, Widget content) {
    double actionBTN_Heigth = 35;
    return AlertDialog(
        backgroundColor: Colors.grey[900],
        contentPadding: EdgeInsets.symmetric(horizontal: MediaQuery.of(context).size.width * 0.02, vertical: MediaQuery.of(context).size.width * 0.01),
        content: StatefulBuilder(builder: (BuildContext context, StateSetter setState) {
          return SingleChildScrollView(child: Form(key: _formkey, child: Container(decoration: BoxDecoration(border: Border.all(width: 3, color: color_HintText)), width: maxRowLen, child: content)));
        }),
        actionsAlignment: MediaQuery.of(context).size.width < 900 ? MainAxisAlignment.center : null,
        actions: [
          Container(
              // height: 35,
              // margin: EdgeInsets.symmetric(horizontal: MediaQuery.of(context).size.width * 0.02),
              child: Wrap(
            runAlignment: WrapAlignment.center,
            alignment: WrapAlignment.center,
            runSpacing: 20,
            spacing: 20,
            children: [
              Container(child: xLayout_AdditionalActions(context, itemInEdit_Clone, actionBTN_Heigth)), //come  XBtnbase( height: 35,
              Container(
                  margin: EdgeInsets.only(right: 20),
                  child: Row(crossAxisAlignment: CrossAxisAlignment.center, mainAxisSize: MainAxisSize.min, children: [
                    btnUpdateChangesShow
                        ? XBtnbase(
                            height: actionBTN_Heigth,
                            width: MediaQuery.of(context).size.width > 900 ? 180 : 100,
                            elevation: 0,
                            label: widget.btnOK_label,
                            decoration: xBoxDecorationStyleCircular_ForMenu(Colors.greenAccent[400]),
                            onPressed: () {
                              xcmd_Save();
                              Navigator.pop(context, widget.itemInEdit);
                            },
                            label_Style: XStyles.xStyTextForDescr(XColors.foregroundDark))
                        : Container(),
                    SizedBox(width: 10),
                    XBtnbase(
                      width: MediaQuery.of(context).size.width > 800 ? 180 : 100,
                      height: actionBTN_Heigth,
                      elevation: 0,
                      label: widget.btnCancel_label ?? "Cancel",
                      decoration: xBoxDecorationStyleCircular_ForMenu(Colors.redAccent),
                      onPressed: () => Navigator.pop(this.context, null),
                      label_Style: XStyles.xStyTextForDescr(XColors.foregroundDark),
                    ),
                  ]))
            ],
          ))
        ]);
  }

  @override
  Widget build(BuildContext context) {
    var maxRowLen = 0.0;
    var rowLen = 0.0;
    var content = Column(
      mainAxisSize: MainAxisSize.min,
      children: widget.xView.cols.groupListsBy((element) => element.originY).entries.map(
        (e) {
          //x orgni sottoROW/grp
          rowLen = 0;
          var child = xLayout_WidgetScheda(
            e,
            e.value.map((e) {
              var xwidgt = widget.editable ? xLayout_CellWidget_Editable(e, itemInEdit_Clone, context, setState) : xLayout_CellWidget(e, itemInEdit_Clone, context);
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
          );
          if (rowLen > maxRowLen) maxRowLen = rowLen;
          return child;
        },
      ).toList(),
    );
    return (widget.modePage_Active.not()
        ? Container(
            margin: EdgeInsets.all(8),
            child: widget.modeDialog_Active.not()
                ////Se la scheda non si trova in un dialog
                ? xLayout_asContainer()
                : xBuilder_asDialog(maxRowLen, content))
        ////Se la scheda si trova in un dialog
        : xLayout_asPage(context));
  }

  xBoxDecorationStyleCircular(Color? color) {
    return BoxDecoration(border: Border.all(color: color ?? Colors.white, width: 1), borderRadius: BorderRadius.circular(20));
  }

  xBoxDecorationStyleCircular_ForMenu(Color? color) {
    return BoxDecoration(color: color, borderRadius: BorderRadius.circular(4));
  }

  XDropSearch<String> xddSearch(String? itemSelected, String label, List<String> liItems, XCol xCol) {
    return XDropSearch<String>(
        label: "${label}".replaceAll("\n", ""),
        itemSelected: itemSelected,
        liItems: liItems,
        al_BackGroundColor: Colors.grey[900],
        itemAsString: (i) => i,
        onChanged_ItemOfDD: (value) {
          itemSelected = value ?? "";
          xOnXCell_Edit_SubmitValue(xCol, itemSelected, setState);
        });
  }

  XDropSearch<MapEntry<String, XEnumsDefs>> xddSearch_ForMapXEnumsEntry_String(MapEntry<String, XEnumsDefs>? item, String label, List<MapEntry<String, XEnumsDefs>> liItems, XCol xCol) {
    return XDropSearch<MapEntry<String, XEnumsDefs>>(
      label: "${label}".replaceAll("\n", ""),
      itemSelected: item,
      menu_BackGroundColor: Colors.grey[900],
      al_BackGroundColor: Colors.grey[900],
      liItems: liItems,
      itemAsString: (i) => i.value.label,
      onChanged_ItemOfDD: (xEnumsValue) {
        if (xEnumsValue == null) {
          item = null;
        } else {
          item = xEnumsValue;
        }
        xOnXCell_Edit_SubmitValue(xCol, item!.value, setState);
      },
      dropdownBuilder: (context, item) {
        return item != null ? Row(children: [Expanded(child: Container(child: Text(item.value.label, textAlign: TextAlign.left, overflow: TextOverflow.ellipsis, style: XStyles.xStyTextForTextBase())))]) : Container();
      },
      itemWidgetBuilder: (context, item, isSelected) {
        return Container(height: 35, alignment: Alignment.centerLeft, child: Text(" " + item.value.label, textAlign: TextAlign.left, overflow: TextOverflow.ellipsis));
      },
    );
  }

  XDropSearch<MapEntry<int, XEnumsDefs>> xddSearch_ForMapXEnumsEntry_Int(MapEntry<int, XEnumsDefs>? item, String? itemSelected, String label, List<MapEntry<int, XEnumsDefs>> liItems, XCol xCol) {
    return XDropSearch<MapEntry<int, XEnumsDefs>>(
      label: "${label}".replaceAll("\n", ""),
      itemSelected: item,
      menu_BackGroundColor: Colors.grey[900],
      al_BackGroundColor: Colors.grey[900],
      liItems: liItems,
      itemAsString: (i) => i.value.label,
      onChanged_ItemOfDD: (xEnumsValue) {
        if (xEnumsValue == null) {
          itemSelected = "";
        } else {
          itemSelected = xEnumsValue.value.toString();
        }
        xOnXCell_Edit_SubmitValue(xCol, itemSelected, setState);
      },
      dropdownBuilder: (context, item) {
        return item != null ? Row(children: [Expanded(child: Container(child: Text(item.value.label, textAlign: TextAlign.left, overflow: TextOverflow.ellipsis, style: XStyles.xStyTextForTextBase())))]) : Container();
      },
      itemWidgetBuilder: (context, item, isSelected) {
        return Container(height: 35, alignment: Alignment.centerLeft, child: Text(" " + item.value.label, textAlign: TextAlign.left, overflow: TextOverflow.ellipsis));
      },
    );
  }

  editPage() {
    setState(() {
      editedPage.value = true;
    });
  }

  Future<bool> cmd_Back() async {
    if (editedPage.value) {
      var res = await showDialog(
          context: context,
          builder: (context) {
            return XAlertDialog(
              title_Text: "Vuoi salvare le tue modifiche?",
              title_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
              actionsBTNarea_Child: Row(children: [
                Expanded(child: XBtnbase(label: "Annulla", label_Style: XStyles.xStyTextForDescr(Colors.yellow), onPressed: () => Navigator.pop(context, null))),
                Expanded(child: XBtnbase(label: "No", label_Style: XStyles.xStyTextForDescr(Colors.red), onPressed: () => Navigator.pop(context, false))),
                Expanded(child: XBtnbase(label: "Si", label_Style: XStyles.xStyTextForDescr(Colors.green), onPressed: () => Navigator.pop(context, true))),
              ]),
            );
          });
      if (res == null) {
        // Navigator.pop(context);
        return false;
      } else if (res) {
        xcmd_Save();
        Navigator.pop(context, widget.itemInEdit);
        return true;
      } else {
        Navigator.pop(context);
        return false;
      }
    } else {
      editedPage.value = false;
      Navigator.pop(context);
      return true;
    }
  }
}

class XEnumsDefs {
  String label = '';
  Color backColor;
  Color textColor;
  XEnumsDefs({required this.backColor, required this.label, required this.textColor});
}
